/*---------------------------------------------------------------------------

   Swyx
   Joseph-von-Fraunhofer-Str. 13a
   44227 Dortmund

  ---------------------------------------------------------------------------


     Project: H.323 Library

      Module: Swyx H.323 extensions helper
 
  --------------------------------------------------------------------------

   $Archive:: /Server/IpPbxSrv v5.0.x.x.root/H323/include/SwyxExtHelper.h  $
    $Author:: Ulrich.findeisen                                             $
      $Date:: 9.08.05 21:10                                                $
   $Modtime:: 9.08.05 16:52                                                $
  $Revision:: 2                                                            $
  $Workfile:: SwyxExtHelper.h                                              $
$NoKeywords: $
----------------------------------------------------------------------------*/


#ifndef __SWYX_EXT_HELPER_H
#define __SWYX_EXT_HELPER_H

#include <stlib.h>
#include "h323.h"
#include "h225.h"


using namespace std;
using namespace Tools;

#define new SNEW


/** Class for the Swyx specific NonStandardData.
    */
const int iSwyxH225NonStandardDataVersion = 2;

class SwyxH225NonStandardData : public Tools::SConnectionObject
{
public:
	enum NSDataChoice
	{
		Unknown = 0,
		CallInfo,
		FaxChannels,
	};

	enum NSDataFaxType
	{
		UnknownFT = 0,
		T30,
		T38,
	};

    SwyxH225NonStandardData::SwyxH225NonStandardData(unsigned uTraceId)
    {
        m_uTraceId  = uTraceId;

		m_NSDataChoice = Unknown;
        m_uFaxType     = UnknownFT;
		m_uFaxChannels = 0;
		m_uLineId      = 0;
    }

    bool BuildSwH225NonStandardData( Tools::SByteVector & rawData );
    bool HandleSwH225NonStandardData( const Tools::SByteVector & rawData );

	NSDataChoice     m_NSDataChoice;

	// CallInfo related stuff
    NSDataFaxType    m_uFaxType;
	unsigned		 m_uLineId;

	// FaxChannels related stuff
	unsigned		 m_uFaxChannels;

    // Vendor identifier including product and version ID
    H225_VendorIdentifier   m_H225VendorIdentifier;

private :

    unsigned         m_uTraceId;
};

#endif // __SWYX_EXT_HELPER_H