//
// h235.h
//
// Code automatically generated by asnparse.
//

#ifndef __H235_H
#define __H235_H

#ifdef __GNUC__
#pragma interface
#endif

#include <stlib.h>

using namespace std;
using namespace Tools;

#include <asner.h>

//
// ChallengeString
//

class H235_ChallengeString : public SAsnOctetString
{
  public:
    H235_ChallengeString(unsigned tag = UniversalOctetString, TagClass tagClass = UniversalTagClass);

    H235_ChallengeString & operator=(const char * v);
    H235_ChallengeString & operator=(const SString & v);
    H235_ChallengeString & operator=(const std::vector<BYTE> & v);
    SObject * Clone() const;
};


//
// TimeStamp
//

class H235_TimeStamp : public SAsnInteger
{
  public:
    H235_TimeStamp(unsigned tag = UniversalInteger, TagClass tagClass = UniversalTagClass);

    H235_TimeStamp & operator=(int v);
    H235_TimeStamp & operator=(unsigned v);
    SObject * Clone() const;
};


//
// RandomVal
//

class H235_RandomVal : public SAsnInteger
{
  public:
    H235_RandomVal(unsigned tag = UniversalInteger, TagClass tagClass = UniversalTagClass);

    H235_RandomVal & operator=(int v);
    H235_RandomVal & operator=(unsigned v);
    SObject * Clone() const;
};


//
// Password
//

class H235_Password : public SAsnBmpString
{
  public:
    H235_Password(unsigned tag = UniversalBmpString, TagClass tagClass = UniversalTagClass);

    H235_Password & operator=(const char * v);
    H235_Password & operator=(const SString & v);
    SObject * Clone() const;
};


//
// Identifier
//

class H235_Identifier : public SAsnBmpString
{
  public:
    H235_Identifier(unsigned tag = UniversalBmpString, TagClass tagClass = UniversalTagClass);

    H235_Identifier & operator=(const char * v);
    H235_Identifier & operator=(const SString & v);
    SObject * Clone() const;
};


//
// KeyMaterial
//

class H235_KeyMaterial : public SAsnBitString
{
  public:
    H235_KeyMaterial(unsigned tag = UniversalBitString, TagClass tagClass = UniversalTagClass);

    SObject * Clone() const;
};


//
// NonStandardParameter
//

class H235_NonStandardParameter : public SAsnSequence
{
  public:
    H235_NonStandardParameter(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObjectId m_nonStandardIdentifier;
    SAsnOctetString m_data;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// DHset
//

class H235_DHset : public SAsnSequence
{
  public:
    H235_DHset(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnBitString m_halfkey;
    SAsnBitString m_modSize;
    SAsnBitString m_generator;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// ECKASDH
//

class H235_ECKASDH_eckasdhp;
class H235_ECKASDH_eckasdh2;

class H235_ECKASDH : public SAsnChoice
{
  public:
    H235_ECKASDH(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_eckasdhp,
      e_eckasdh2
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H235_ECKASDH_eckasdhp &() const;
#else
    operator H235_ECKASDH_eckasdhp &();
    operator const H235_ECKASDH_eckasdhp &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H235_ECKASDH_eckasdh2 &() const;
#else
    operator H235_ECKASDH_eckasdh2 &();
    operator const H235_ECKASDH_eckasdh2 &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// ECDSAlikeSignature
//

class H235_ECDSAlikeSignature : public SAsnSequence
{
  public:
    H235_ECDSAlikeSignature(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnBitString m_r;
    SAsnBitString m_s;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// TypedCertificate
//

class H235_TypedCertificate : public SAsnSequence
{
  public:
    H235_TypedCertificate(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObjectId m_type;
    SAsnOctetString m_certificate;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// AuthenticationBES
//

class H235_AuthenticationBES : public SAsnChoice
{
  public:
    H235_AuthenticationBES(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_default,
      e_radius
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// AuthenticationMechanism
//

class H235_NonStandardParameter;
class H235_AuthenticationBES;

class H235_AuthenticationMechanism : public SAsnChoice
{
  public:
    H235_AuthenticationMechanism(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_dhExch,
      e_pwdSymEnc,
      e_pwdHash,
      e_certSign,
      e_ipsec,
      e_tls,
      e_nonStandard,
      e_authenticationBES
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H235_NonStandardParameter &() const;
#else
    operator H235_NonStandardParameter &();
    operator const H235_NonStandardParameter &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H235_AuthenticationBES &() const;
#else
    operator H235_AuthenticationBES &();
    operator const H235_AuthenticationBES &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// ClearToken
//

class H235_ClearToken : public SAsnSequence
{
  public:
    H235_ClearToken(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_timeStamp,
      e_password,
      e_dhkey,
      e_challenge,
      e_random,
      e_certificate,
      e_generalID,
      e_nonStandard,
      e_eckasdhkey,
      e_sendersID
    };

    SAsnObjectId m_tokenOID;
    H235_TimeStamp m_timeStamp;
    H235_Password m_password;
    H235_DHset m_dhkey;
    H235_ChallengeString m_challenge;
    H235_RandomVal m_random;
    H235_TypedCertificate m_certificate;
    H235_Identifier m_generalID;
    H235_NonStandardParameter m_nonStandard;
    H235_ECKASDH m_eckasdhkey;
    H235_Identifier m_sendersID;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// IV8
//

class H235_IV8 : public SAsnOctetString
{
  public:
    H235_IV8(unsigned tag = UniversalOctetString, TagClass tagClass = UniversalTagClass);

    H235_IV8 & operator=(const char * v);
    H235_IV8 & operator=(const SString & v);
    H235_IV8 & operator=(const std::vector<BYTE> & v);
    SObject * Clone() const;
};


//
// IV16
//

class H235_IV16 : public SAsnOctetString
{
  public:
    H235_IV16(unsigned tag = UniversalOctetString, TagClass tagClass = UniversalTagClass);

    H235_IV16 & operator=(const char * v);
    H235_IV16 & operator=(const SString & v);
    H235_IV16 & operator=(const std::vector<BYTE> & v);
    SObject * Clone() const;
};


//
// Params
//

class H235_Params : public SAsnSequence
{
  public:
    H235_Params(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_ranInt,
      e_iv8,
      e_iv16
    };

    SAsnInteger m_ranInt;
    H235_IV8 m_iv8;
    H235_IV16 m_iv16;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// EncodedGeneralToken
//

typedef H235_ClearToken H235_EncodedGeneralToken;


//
// PwdCertToken
//

class H235_PwdCertToken : public H235_ClearToken
{
  public:
    H235_PwdCertToken(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SObject * Clone() const;
};


//
// EncodedPwdCertToken
//

typedef H235_PwdCertToken H235_EncodedPwdCertToken;


//
// ReturnSig
//

class H235_ReturnSig : public SAsnSequence
{
  public:
    H235_ReturnSig(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_requestRandom,
      e_certificate
    };

    H235_Identifier m_generalId;
    H235_RandomVal m_responseRandom;
    H235_RandomVal m_requestRandom;
    H235_TypedCertificate m_certificate;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// EncodedReturnSig
//

typedef H235_ReturnSig H235_EncodedReturnSig;


//
// KeySyncMaterial
//

class H235_KeySyncMaterial : public SAsnSequence
{
  public:
    H235_KeySyncMaterial(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    H235_Identifier m_generalID;
    H235_KeyMaterial m_keyMaterial;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// EncodedKeySyncMaterial
//

typedef H235_KeySyncMaterial H235_EncodedKeySyncMaterial;


//
// ECKASDH_eckasdhp
//

class H235_ECKASDH_eckasdhp : public SAsnSequence
{
  public:
    H235_ECKASDH_eckasdhp(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnBitString m_public_key;
    SAsnBitString m_modulus;
    SAsnBitString m_base;
    SAsnBitString m_weierstrassA;
    SAsnBitString m_weierstrassB;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// ECKASDH_eckasdh2
//

class H235_ECKASDH_eckasdh2 : public SAsnSequence
{
  public:
    H235_ECKASDH_eckasdh2(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnBitString m_public_key;
    SAsnBitString m_fieldSize;
    SAsnBitString m_base;
    SAsnBitString m_weierstrassA;
    SAsnBitString m_weierstrassB;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// SIGNED
//

template <class ToBeSigned>
class H235_SIGNED : public SAsnSequence
{
  public:
    H235_SIGNED(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    ToBeSigned m_toBeSigned;
    SAsnObjectId m_algorithmOID;
    H235_Params m_paramS;
    SAsnBitString m_signature;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// ENCRYPTED
//

template <class ToBeEncrypted>
class H235_ENCRYPTED : public SAsnSequence
{
  public:
    H235_ENCRYPTED(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObjectId m_algorithmOID;
    H235_Params m_paramS;
    SAsnOctetString m_encryptedData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// HASHED
//

template <class ToBeHashed>
class H235_HASHED : public SAsnSequence
{
  public:
    H235_HASHED(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObjectId m_algorithmOID;
    H235_Params m_paramS;
    SAsnBitString m_hash;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// CryptoToken
//

class H235_CryptoToken_cryptoEncryptedToken;
class H235_CryptoToken_cryptoSignedToken;
class H235_CryptoToken_cryptoHashedToken;

class H235_CryptoToken : public SAsnChoice
{
  public:
    H235_CryptoToken(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_cryptoEncryptedToken,
      e_cryptoSignedToken,
      e_cryptoHashedToken,
      e_cryptoPwdEncr
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H235_CryptoToken_cryptoEncryptedToken &() const;
#else
    operator H235_CryptoToken_cryptoEncryptedToken &();
    operator const H235_CryptoToken_cryptoEncryptedToken &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H235_CryptoToken_cryptoSignedToken &() const;
#else
    operator H235_CryptoToken_cryptoSignedToken &();
    operator const H235_CryptoToken_cryptoSignedToken &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H235_CryptoToken_cryptoHashedToken &() const;
#else
    operator H235_CryptoToken_cryptoHashedToken &();
    operator const H235_CryptoToken_cryptoHashedToken &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H235_ENCRYPTED<H235_EncodedPwdCertToken> &() const;
#else
    operator H235_ENCRYPTED<H235_EncodedPwdCertToken> &();
    operator const H235_ENCRYPTED<H235_EncodedPwdCertToken> &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// KeySignedMaterial
//

class H235_KeySignedMaterial : public SAsnSequence
{
  public:
    H235_KeySignedMaterial(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_srandom,
      e_timeStamp
    };

    H235_Identifier m_generalId;
    H235_RandomVal m_mrandom;
    H235_RandomVal m_srandom;
    H235_TimeStamp m_timeStamp;
    H235_ENCRYPTED<H235_EncodedKeySyncMaterial> m_encrptval;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// EncodedKeySignedMaterial
//

typedef H235_KeySignedMaterial H235_EncodedKeySignedMaterial;


//
// H235CertificateSignature
//

class H235_H235CertificateSignature : public SAsnSequence
{
  public:
    H235_H235CertificateSignature(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_requesterRandom
    };

    H235_TypedCertificate m_certificate;
    H235_RandomVal m_responseRandom;
    H235_RandomVal m_requesterRandom;
    H235_SIGNED<H235_EncodedReturnSig> m_signature;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// CryptoToken_cryptoEncryptedToken
//

class H235_CryptoToken_cryptoEncryptedToken : public SAsnSequence
{
  public:
    H235_CryptoToken_cryptoEncryptedToken(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObjectId m_tokenOID;
    H235_ENCRYPTED<H235_EncodedGeneralToken> m_token;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// CryptoToken_cryptoSignedToken
//

class H235_CryptoToken_cryptoSignedToken : public SAsnSequence
{
  public:
    H235_CryptoToken_cryptoSignedToken(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObjectId m_tokenOID;
    H235_SIGNED<H235_EncodedGeneralToken> m_token;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// CryptoToken_cryptoHashedToken
//

class H235_CryptoToken_cryptoHashedToken : public SAsnSequence
{
  public:
    H235_CryptoToken_cryptoHashedToken(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObjectId m_tokenOID;
    H235_ClearToken m_hashedVals;
    H235_HASHED<H235_EncodedGeneralToken> m_token;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// H235Key
//

class H235_KeyMaterial;

class H235_H235Key : public SAsnChoice
{
  public:
    H235_H235Key(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_secureChannel,
      e_sharedSecret,
      e_certProtectedKey
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H235_KeyMaterial &() const;
#else
    operator H235_KeyMaterial &();
    operator const H235_KeyMaterial &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H235_ENCRYPTED<H235_EncodedKeySyncMaterial> &() const;
#else
    operator H235_ENCRYPTED<H235_EncodedKeySyncMaterial> &();
    operator const H235_ENCRYPTED<H235_EncodedKeySyncMaterial> &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H235_SIGNED<H235_EncodedKeySignedMaterial> &() const;
#else
    operator H235_SIGNED<H235_EncodedKeySignedMaterial> &();
    operator const H235_SIGNED<H235_EncodedKeySignedMaterial> &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


#endif // __H235_H


// End of h235.h
