//
// ldap.h
//
// Code automatically generated by asnparse.
//

#ifndef __LDAP_H
#define __LDAP_H

#ifdef __GNUC__
#pragma interface
#endif

#include <stlib.h>

using namespace std;
using namespace Tools;

#include <asner.h>

//
// UnbindRequest
//

class LDAP_UnbindRequest : public SAsnNull
{
  public:
    LDAP_UnbindRequest(unsigned tag = 2, TagClass tagClass = ApplicationTagClass);

    SObject * Clone() const;
};


//
// SearchResponse
//

class LDAP_SearchResponse_entry;
class LDAP_LDAPResult;

class LDAP_SearchResponse : public SAsnChoice
{
  public:
    LDAP_SearchResponse(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_entry,
      e_resultCode
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator LDAP_SearchResponse_entry &() const;
#else
    operator LDAP_SearchResponse_entry &();
    operator const LDAP_SearchResponse_entry &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator LDAP_LDAPResult &() const;
#else
    operator LDAP_LDAPResult &();
    operator const LDAP_LDAPResult &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// MessageID
//

class LDAP_MessageID : public SAsnInteger
{
  public:
    LDAP_MessageID(unsigned tag = UniversalInteger, TagClass tagClass = UniversalTagClass);

    LDAP_MessageID & operator=(int v);
    LDAP_MessageID & operator=(unsigned v);
    SObject * Clone() const;
};


//
// Filter
//

class LDAP_ArrayOf_Filter;
class LDAP_ArrayOf_Filter;
class LDAP_AttributeValueAssertion;
class LDAP_SubstringFilter;
class LDAP_AttributeValueAssertion;
class LDAP_AttributeValueAssertion;
class LDAP_AttributeType;
class LDAP_AttributeValueAssertion;

class LDAP_Filter : public SAsnChoice
{
  public:
    LDAP_Filter(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_and,
      e_or,
      e_equalityMatch,
      e_substrings,
      e_greaterOrEqual,
      e_lessOrEqual,
      e_present,
      e_approxMatch
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator LDAP_ArrayOf_Filter &() const;
#else
    operator LDAP_ArrayOf_Filter &();
    operator const LDAP_ArrayOf_Filter &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator LDAP_AttributeValueAssertion &() const;
#else
    operator LDAP_AttributeValueAssertion &();
    operator const LDAP_AttributeValueAssertion &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator LDAP_SubstringFilter &() const;
#else
    operator LDAP_SubstringFilter &();
    operator const LDAP_SubstringFilter &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator LDAP_AttributeType &() const;
#else
    operator LDAP_AttributeType &();
    operator const LDAP_AttributeType &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// AttributeValue
//

class LDAP_AttributeValue : public SAsnOctetString
{
  public:
    LDAP_AttributeValue(unsigned tag = UniversalOctetString, TagClass tagClass = UniversalTagClass);

    LDAP_AttributeValue & operator=(const char * v);
    LDAP_AttributeValue & operator=(const SString & v);
    LDAP_AttributeValue & operator=(const std::vector<BYTE> & v);
    SObject * Clone() const;
};


//
// LDAPString
//

class LDAP_LDAPString : public SAsnOctetString
{
  public:
    LDAP_LDAPString(unsigned tag = UniversalOctetString, TagClass tagClass = UniversalTagClass);

    LDAP_LDAPString & operator=(const char * v);
    LDAP_LDAPString & operator=(const SString & v);
    LDAP_LDAPString & operator=(const std::vector<BYTE> & v);
    SObject * Clone() const;
};


//
// LDAPMessage_protocolOp
//

class LDAP_SearchRequest;
class LDAP_SearchResponse;
class LDAP_ModifyRequest;
class LDAP_ModifyResponse;
class LDAP_AddRequest;
class LDAP_AddResponse;
class LDAP_DelRequest;
class LDAP_DelResponse;
class LDAP_ModifyRDNRequest;
class LDAP_ModifyRDNResponse;
class LDAP_CompareRequest;
class LDAP_CompareResponse;
class LDAP_BindRequest;
class LDAP_BindResponse;
class LDAP_AbandonRequest;
class LDAP_UnbindRequest;

class LDAP_LDAPMessage_protocolOp : public SAsnChoice
{
  public:
    LDAP_LDAPMessage_protocolOp(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_searchRequest,
      e_modifyRequest,
      e_modifyResponse,
      e_addRequest,
      e_addResponse,
      e_delRequest,
      e_delResponse,
      e_modifyRDNRequest,
      e_modifyRDNResponse,
      e_compareDNRequest,
      e_compareDNResponse,
      e_bindRequest,
      e_bindResponse,
      e_abandonRequest,
      e_unbindRequest
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator LDAP_SearchRequest &() const;
#else
    operator LDAP_SearchRequest &();
    operator const LDAP_SearchRequest &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator LDAP_SearchResponse &() const;
#else
    operator LDAP_SearchResponse &();
    operator const LDAP_SearchResponse &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator LDAP_ModifyRequest &() const;
#else
    operator LDAP_ModifyRequest &();
    operator const LDAP_ModifyRequest &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator LDAP_ModifyResponse &() const;
#else
    operator LDAP_ModifyResponse &();
    operator const LDAP_ModifyResponse &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator LDAP_AddRequest &() const;
#else
    operator LDAP_AddRequest &();
    operator const LDAP_AddRequest &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator LDAP_AddResponse &() const;
#else
    operator LDAP_AddResponse &();
    operator const LDAP_AddResponse &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator LDAP_DelRequest &() const;
#else
    operator LDAP_DelRequest &();
    operator const LDAP_DelRequest &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator LDAP_DelResponse &() const;
#else
    operator LDAP_DelResponse &();
    operator const LDAP_DelResponse &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator LDAP_ModifyRDNRequest &() const;
#else
    operator LDAP_ModifyRDNRequest &();
    operator const LDAP_ModifyRDNRequest &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator LDAP_ModifyRDNResponse &() const;
#else
    operator LDAP_ModifyRDNResponse &();
    operator const LDAP_ModifyRDNResponse &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator LDAP_CompareRequest &() const;
#else
    operator LDAP_CompareRequest &();
    operator const LDAP_CompareRequest &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator LDAP_CompareResponse &() const;
#else
    operator LDAP_CompareResponse &();
    operator const LDAP_CompareResponse &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator LDAP_BindRequest &() const;
#else
    operator LDAP_BindRequest &();
    operator const LDAP_BindRequest &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator LDAP_BindResponse &() const;
#else
    operator LDAP_BindResponse &();
    operator const LDAP_BindResponse &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator LDAP_AbandonRequest &() const;
#else
    operator LDAP_AbandonRequest &();
    operator const LDAP_AbandonRequest &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator LDAP_UnbindRequest &() const;
#else
    operator LDAP_UnbindRequest &();
    operator const LDAP_UnbindRequest &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// BindRequest_authentication
//

class LDAP_BindRequest_authentication : public SAsnChoice
{
  public:
    LDAP_BindRequest_authentication(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_simple,
      e_krbv42LDAP,
      e_krbv42DSA
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// SearchRequest_scope
//

class LDAP_SearchRequest_scope : public SAsnEnumeration
{
  public:
    LDAP_SearchRequest_scope(unsigned tag = UniversalEnumeration, TagClass tagClass = UniversalTagClass);

    enum Enumerations {
      e_baseObject,
      e_singleLevel,
      e_wholeSubtree
    };

    LDAP_SearchRequest_scope & operator=(unsigned v);
    SObject * Clone() const;
};


//
// SearchRequest_derefAliases
//

class LDAP_SearchRequest_derefAliases : public SAsnEnumeration
{
  public:
    LDAP_SearchRequest_derefAliases(unsigned tag = UniversalEnumeration, TagClass tagClass = UniversalTagClass);

    enum Enumerations {
      e_neverDerefAliases,
      e_derefInSearching,
      e_derefFindingBaseObj,
      e_alwaysDerefAliases
    };

    LDAP_SearchRequest_derefAliases & operator=(unsigned v);
    SObject * Clone() const;
};


//
// ArrayOf_AttributeType
//

class LDAP_AttributeType;

class LDAP_ArrayOf_AttributeType : public SAsnArray
{
  public:
    LDAP_ArrayOf_AttributeType(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    LDAP_AttributeType & LDAP_ArrayOf_AttributeType::operator[](int i) const;
    SObject * Clone() const;
};


//
// ModifyRequest_modifications
//

class LDAP_ModifyRequest_modifications_subtype;

class LDAP_ModifyRequest_modifications : public SAsnArray
{
  public:
    LDAP_ModifyRequest_modifications(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    LDAP_ModifyRequest_modifications_subtype & LDAP_ModifyRequest_modifications::operator[](int i) const;
    SObject * Clone() const;
};


//
// AddRequest_attrs
//

class LDAP_AddRequest_attrs_subtype;

class LDAP_AddRequest_attrs : public SAsnArray
{
  public:
    LDAP_AddRequest_attrs(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    LDAP_AddRequest_attrs_subtype & LDAP_AddRequest_attrs::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_Filter
//

class LDAP_Filter;

class LDAP_ArrayOf_Filter : public SAsnArray
{
  public:
    LDAP_ArrayOf_Filter(unsigned tag = 0, TagClass tagClass = ContextSpecificTagClass);

    SAsnObject * CreateObject() const;
    LDAP_Filter & LDAP_ArrayOf_Filter::operator[](int i) const;
    SObject * Clone() const;
};


//
// LDAPResult_resultCode
//

class LDAP_LDAPResult_resultCode : public SAsnEnumeration
{
  public:
    LDAP_LDAPResult_resultCode(unsigned tag = UniversalEnumeration, TagClass tagClass = UniversalTagClass);

    enum Enumerations {
      e_success,
      e_operationsError,
      e_protocolError,
      e_timeLimitExceeded,
      e_sizeLimitExceeded,
      e_compareFalse,
      e_compareTrue,
      e_authMethodNotSupported,
      e_strongAuthRequired,
      e_noSuchAttribute = 16,
      e_undefinedAttributeType,
      e_inappropriateMatching,
      e_constraintViolation,
      e_attributeOrValueExists,
      e_invalidAttributeSyntax,
      e_noSuchObject = 32,
      e_aliasProblem,
      e_invalidDNSyntax,
      e_isLeaf,
      e_aliasDereferencingProblem,
      e_inappropriateAuthentication = 48,
      e_invalidCredentials,
      e_insufficientAccessRights,
      e_busy,
      e_unavailable,
      e_unwillingToPerform,
      e_loopDetect,
      e_namingViolation = 64,
      e_objectClassViolation,
      e_notAllowedOnNonLeaf,
      e_notAllowedOnRDN,
      e_entryAlreadyExists,
      e_objectClassModsProhibited,
      e_other = 80
    };

    LDAP_LDAPResult_resultCode & operator=(unsigned v);
    SObject * Clone() const;
};


//
// SubstringFilter_value
//

class LDAP_SubstringFilter_value_subtype;

class LDAP_SubstringFilter_value : public SAsnArray
{
  public:
    LDAP_SubstringFilter_value(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    LDAP_SubstringFilter_value_subtype & LDAP_SubstringFilter_value::operator[](int i) const;
    SObject * Clone() const;
};


//
// SearchResponse_entry_attributes
//

class LDAP_SearchResponse_entry_attributes_subtype;

class LDAP_SearchResponse_entry_attributes : public SAsnArray
{
  public:
    LDAP_SearchResponse_entry_attributes(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    LDAP_SearchResponse_entry_attributes_subtype & LDAP_SearchResponse_entry_attributes::operator[](int i) const;
    SObject * Clone() const;
};


//
// SubstringFilter_value_subtype
//

class LDAP_LDAPString;
class LDAP_LDAPString;
class LDAP_LDAPString;

class LDAP_SubstringFilter_value_subtype : public SAsnChoice
{
  public:
    LDAP_SubstringFilter_value_subtype(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_initial,
      e_any,
      e_final
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator LDAP_LDAPString &() const;
#else
    operator LDAP_LDAPString &();
    operator const LDAP_LDAPString &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// ModifyRequest_modifications_subtype_operation
//

class LDAP_ModifyRequest_modifications_subtype_operation : public SAsnEnumeration
{
  public:
    LDAP_ModifyRequest_modifications_subtype_operation(unsigned tag = UniversalEnumeration, TagClass tagClass = UniversalTagClass);

    enum Enumerations {
      e_add,
      e_delete,
      e_replace
    };

    LDAP_ModifyRequest_modifications_subtype_operation & operator=(unsigned v);
    SObject * Clone() const;
};


//
// ArrayOf_AttributeValue
//

class LDAP_AttributeValue;

class LDAP_ArrayOf_AttributeValue : public SAsnArray
{
  public:
    LDAP_ArrayOf_AttributeValue(unsigned tag = UniversalSet, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    LDAP_AttributeValue & LDAP_ArrayOf_AttributeValue::operator[](int i) const;
    SObject * Clone() const;
};


//
// LDAPMessage
//

class LDAP_LDAPMessage : public SAsnSequence
{
  public:
    LDAP_LDAPMessage(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    LDAP_MessageID m_messageID;
    LDAP_LDAPMessage_protocolOp m_protocolOp;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// AbandonRequest
//

class LDAP_AbandonRequest : public LDAP_MessageID
{
  public:
    LDAP_AbandonRequest(unsigned tag = UniversalInteger, TagClass tagClass = UniversalTagClass);

    LDAP_AbandonRequest & operator=(int v);
    LDAP_AbandonRequest & operator=(unsigned v);
    SObject * Clone() const;
};


//
// LDAPDN
//

class LDAP_LDAPDN : public LDAP_LDAPString
{
  public:
    LDAP_LDAPDN(unsigned tag = UniversalOctetString, TagClass tagClass = UniversalTagClass);

    LDAP_LDAPDN & operator=(const char * v);
    LDAP_LDAPDN & operator=(const SString & v);
    LDAP_LDAPDN & operator=(const std::vector<BYTE> & v);
    SObject * Clone() const;
};


//
// RelativeLDAPDN
//

class LDAP_RelativeLDAPDN : public LDAP_LDAPString
{
  public:
    LDAP_RelativeLDAPDN(unsigned tag = UniversalOctetString, TagClass tagClass = UniversalTagClass);

    LDAP_RelativeLDAPDN & operator=(const char * v);
    LDAP_RelativeLDAPDN & operator=(const SString & v);
    LDAP_RelativeLDAPDN & operator=(const std::vector<BYTE> & v);
    SObject * Clone() const;
};


//
// LDAPResult
//

class LDAP_LDAPResult : public SAsnSequence
{
  public:
    LDAP_LDAPResult(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    LDAP_LDAPResult_resultCode m_resultCode;
    LDAP_LDAPDN m_matchedDN;
    LDAP_LDAPString m_errorMessage;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// AttributeType
//

class LDAP_AttributeType : public LDAP_LDAPString
{
  public:
    LDAP_AttributeType(unsigned tag = UniversalOctetString, TagClass tagClass = UniversalTagClass);

    LDAP_AttributeType & operator=(const char * v);
    LDAP_AttributeType & operator=(const SString & v);
    LDAP_AttributeType & operator=(const std::vector<BYTE> & v);
    SObject * Clone() const;
};


//
// AttributeValueAssertion
//

class LDAP_AttributeValueAssertion : public SAsnSequence
{
  public:
    LDAP_AttributeValueAssertion(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    LDAP_AttributeType m_attributeType;
    LDAP_AttributeValue m_attributeValue;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// SubstringFilter
//

class LDAP_SubstringFilter : public SAsnSequence
{
  public:
    LDAP_SubstringFilter(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    LDAP_AttributeType m_type;
    LDAP_SubstringFilter_value m_value;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// SearchResponse_entry
//

class LDAP_SearchResponse_entry : public SAsnSequence
{
  public:
    LDAP_SearchResponse_entry(unsigned tag = 4, TagClass tagClass = ApplicationTagClass);

    LDAP_LDAPDN m_objectName;
    LDAP_SearchResponse_entry_attributes m_attributes;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// AddRequest_attrs_subtype
//

class LDAP_AddRequest_attrs_subtype : public SAsnSequence
{
  public:
    LDAP_AddRequest_attrs_subtype(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    LDAP_AttributeType m_type;
    LDAP_ArrayOf_AttributeValue m_values;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// SearchResponse_entry_attributes_subtype
//

class LDAP_SearchResponse_entry_attributes_subtype : public SAsnSequence
{
  public:
    LDAP_SearchResponse_entry_attributes_subtype(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    LDAP_AttributeType m_type;
    LDAP_ArrayOf_AttributeValue m_values;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// ModifyRequest_modifications_subtype_modification
//

class LDAP_ModifyRequest_modifications_subtype_modification : public SAsnSequence
{
  public:
    LDAP_ModifyRequest_modifications_subtype_modification(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    LDAP_AttributeType m_type;
    LDAP_ArrayOf_AttributeValue m_values;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// BindRequest
//

class LDAP_BindRequest : public SAsnSequence
{
  public:
    LDAP_BindRequest(unsigned tag = 0, TagClass tagClass = ApplicationTagClass);

    SAsnInteger m_version;
    LDAP_LDAPDN m_name;
    LDAP_BindRequest_authentication m_authentication;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// BindResponse
//

class LDAP_BindResponse : public LDAP_LDAPResult
{
  public:
    LDAP_BindResponse(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SObject * Clone() const;
};


//
// SearchRequest
//

class LDAP_SearchRequest : public SAsnSequence
{
  public:
    LDAP_SearchRequest(unsigned tag = 3, TagClass tagClass = ApplicationTagClass);

    LDAP_LDAPDN m_baseObject;
    LDAP_SearchRequest_scope m_scope;
    LDAP_SearchRequest_derefAliases m_derefAliases;
    SAsnInteger m_sizeLimit;
    SAsnInteger m_timeLimit;
    SAsnBoolean m_attrsOnly;
    LDAP_Filter m_filter;
    LDAP_ArrayOf_AttributeType m_attributes;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// ModifyRequest
//

class LDAP_ModifyRequest : public SAsnSequence
{
  public:
    LDAP_ModifyRequest(unsigned tag = 6, TagClass tagClass = ApplicationTagClass);

    LDAP_LDAPDN m_object;
    LDAP_ModifyRequest_modifications m_modifications;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// ModifyResponse
//

class LDAP_ModifyResponse : public LDAP_LDAPResult
{
  public:
    LDAP_ModifyResponse(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SObject * Clone() const;
};


//
// AddRequest
//

class LDAP_AddRequest : public SAsnSequence
{
  public:
    LDAP_AddRequest(unsigned tag = 8, TagClass tagClass = ApplicationTagClass);

    LDAP_LDAPDN m_entry;
    LDAP_AddRequest_attrs m_attrs;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// AddResponse
//

class LDAP_AddResponse : public LDAP_LDAPResult
{
  public:
    LDAP_AddResponse(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SObject * Clone() const;
};


//
// DelRequest
//

class LDAP_DelRequest : public LDAP_LDAPDN
{
  public:
    LDAP_DelRequest(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    LDAP_DelRequest & operator=(const char * v);
    LDAP_DelRequest & operator=(const SString & v);
    LDAP_DelRequest & operator=(const std::vector<BYTE> & v);
    SObject * Clone() const;
};


//
// DelResponse
//

class LDAP_DelResponse : public LDAP_LDAPResult
{
  public:
    LDAP_DelResponse(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SObject * Clone() const;
};


//
// ModifyRDNRequest
//

class LDAP_ModifyRDNRequest : public SAsnSequence
{
  public:
    LDAP_ModifyRDNRequest(unsigned tag = 12, TagClass tagClass = ApplicationTagClass);

    LDAP_LDAPDN m_entry;
    LDAP_RelativeLDAPDN m_newrdn;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// ModifyRDNResponse
//

class LDAP_ModifyRDNResponse : public LDAP_LDAPResult
{
  public:
    LDAP_ModifyRDNResponse(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SObject * Clone() const;
};


//
// CompareRequest
//

class LDAP_CompareRequest : public SAsnSequence
{
  public:
    LDAP_CompareRequest(unsigned tag = 14, TagClass tagClass = ApplicationTagClass);

    LDAP_LDAPDN m_entry;
    LDAP_AttributeValueAssertion m_ava;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// CompareResponse
//

class LDAP_CompareResponse : public LDAP_LDAPResult
{
  public:
    LDAP_CompareResponse(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SObject * Clone() const;
};


//
// ModifyRequest_modifications_subtype
//

class LDAP_ModifyRequest_modifications_subtype : public SAsnSequence
{
  public:
    LDAP_ModifyRequest_modifications_subtype(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    LDAP_ModifyRequest_modifications_subtype_operation m_operation;
    LDAP_ModifyRequest_modifications_subtype_modification m_modification;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


#endif // __LDAP_H


// End of ldap.h
