/*---------------------------------------------------------------------------

   Swyx Communications AG
   Joseph-von-Fraunhofer-Str. 13a
   44227 Dortmund

  ---------------------------------------------------------------------------

  The contents of this file are subject to the Mozilla Public License
  Version 1.0 (the "License"); you may not use this file except in
  compliance with the License. You may obtain a copy of the License at
  http://www.mozilla.org/MPL/

  Software distributed under the License is distributed on an "AS IS"
  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
  the License for the specific language governing rights and limitations
  under the License.

  The Original Code is Open H323 Library.

  The Initial Developer of the Original Code is Equivalence Pty. Ltd.

  Portions of this code were written with the assistance of funding from
  Vovida Networks, Inc. http://www.vovida.com.

  Portions created by Swyx Communications AG are
  Copyright (C) 2000-2002 Swyx Communications AG.
  All Rights Reserved.

  Contributor(s): ______________________________________.

  ---------------------------------------------------------------------------

     Project: H.323 Library

      Module: Video I/O
 
    Comments: Video I/O Device handlers

  --------------------------------------------------------------------------

   $Archive:: /H323/include/videoio.h                                      $
    $Author:: Findeisen                                                    $
      $Date:: 7.05.02 16:37                                                $
   $Modtime:: 7.05.02 16:22                                                $
  $Revision:: 4                                                            $
  $Workfile:: videoio.h                                                    $
$NoKeywords: $
----------------------------------------------------------------------------*/


#ifndef __VIDEOIO_H
#define __VIDEOIO_H

#include <stlib.h>


class H323VideoDevice : public Tools::SObject
{
  public:
    virtual void Close()
      { }

    virtual void Redraw(const BYTE * frame)
      { Refresh(frame); }

    virtual void SetSize(int _width, int _height)
      { width = _width; height = _height; }

  protected:
    virtual void WriteLineSegment(int x, int y, int len, const BYTE * data) = 0;
    virtual void Refresh(const BYTE * frame);

    int width;
    int height;
};

class PPMVideoOutputDevice : public H323VideoDevice
{
  public:
    PPMVideoOutputDevice();
    void WriteLineSegment(int x, int y, int len, const BYTE * data);

  protected:
    void Refresh(const BYTE * frame);

    int frameNumber;
    Tools::SFile file;
    Tools::SByteVector buffer;
};

#endif // __VIDEOIO_H

