/*---------------------------------------------------------------------------

   Swyx Communications AG
   Joseph-von-Fraunhofer-Str. 13a
   44227 Dortmund

  ---------------------------------------------------------------------------

  The contents of this file are subject to the Mozilla Public License
  Version 1.0 (the "License"); you may not use this file except in
  compliance with the License. You may obtain a copy of the License at
  http://www.mozilla.org/MPL/

  Software distributed under the License is distributed on an "AS IS"
  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
  the License for the specific language governing rights and limitations
  under the License.

  The Original Code is Open H323 Library.

  The Initial Developer of the Original Code is Equivalence Pty. Ltd.

  Portions of this code were written with the assistance of funding from
  Vovida Networks, Inc. http://www.vovida.com.

  Portions created by Swyx Communications AG are
  Copyright (C) 2000-2002 Swyx Communications AG.
  All Rights Reserved.

  Contributor(s): ______________________________________.

  ---------------------------------------------------------------------------

     Project: H.323 Library

      Module: X.224 
 
    Comments: X.224 protocol handler (simplest class)

  --------------------------------------------------------------------------

   $Archive:: /Server/IpPbxSrv.root/H323/include/x224.h                    $
    $Author:: Martin.hueser                                                $
      $Date:: 20.12.05 18:34                                               $
   $Modtime:: 16.12.05 16:35                                               $
  $Revision:: 2                                                            $
  $Workfile:: x224.h                                                       $
$NoKeywords: $
----------------------------------------------------------------------------*/

#ifndef __X224_H
#define __X224_H

#include <stlib.h>


// X.224 Class Zero PDU

class X224 : public Tools::SObject
{
  public:
    enum Codes {
      ConnectRequest = 0xe0,
      ConnectConfirm = 0xd0,
      DataPDU = 0xf0
    };

    X224();

    void BuildConnectRequest();
    void BuildConnectConfirm();
    void BuildData(const Tools::SByteVector & data);

    void PrintOn(std::ostream & strm) const;
    bool Decode(const Tools::SByteVector & rawData);
    bool Encode(Tools::SByteVector & rawData) const;

    int GetCode() const { return header[0]; }
    const Tools::SByteVector & GetData() const { return data; }

  private:
    Tools::SByteVector header;
    Tools::SByteVector data;
};


#endif // __X224_H
