//
// h235_t.cpp
//
// Code automatically generated by asnparse.
//

//
// SIGNED
//

template <class ToBeSigned>
H235_SIGNED<ToBeSigned>::H235_SIGNED(unsigned tag, SAsnObject::TagClass tagClass)
  : SAsnSequence(tag, tagClass, 0, false, 0)
{
}


#ifndef SASN_NOPRINTON
template <class ToBeSigned>
void H235_SIGNED<ToBeSigned>::PrintOn(ostream & strm) const
{
  long long indent = strm.precision() + 2;
  strm << "{\n" << STrace::MultiLinePrefix;
  strm << setw(indent+13) << "toBeSigned = " << setprecision(indent) << m_toBeSigned << '\n' << STrace::MultiLinePrefix;
  strm << setw(indent+15) << "algorithmOID = " << setprecision(indent) << m_algorithmOID << '\n' << STrace::MultiLinePrefix;
  strm << setw(indent+9) << "paramS = " << setprecision(indent) << m_paramS << '\n' << STrace::MultiLinePrefix;
  strm << setw(indent+12) << "signature = " << setprecision(indent) << m_signature << '\n' << STrace::MultiLinePrefix;
  strm << setw(indent-1) << "}";
}
#endif


template <class ToBeSigned>
SObject::Comparison H235_SIGNED<ToBeSigned>::Compare(const SObject & obj) const
{
#ifndef SASN_LEANANDMEAN
  SAssert(typeid(H235_SIGNED<ToBeSigned>) == typeid(*this), SInvalidCast);
#endif
  const H235_SIGNED<ToBeSigned> & other = (const H235_SIGNED<ToBeSigned> &)obj;

  Comparison result;

  if ((result = m_toBeSigned.Compare(other.m_toBeSigned)) != EqualTo)
    return result;
  if ((result = m_algorithmOID.Compare(other.m_algorithmOID)) != EqualTo)
    return result;
  if ((result = m_paramS.Compare(other.m_paramS)) != EqualTo)
    return result;
  if ((result = m_signature.Compare(other.m_signature)) != EqualTo)
    return result;

  return SAsnSequence::Compare(other);
}


template <class ToBeSigned>
int H235_SIGNED<ToBeSigned>::GetDataLength() const
{
  return m_toBeSigned.GetObjectLength() +
         m_algorithmOID.GetObjectLength() +
         m_paramS.GetObjectLength() +
         m_signature.GetObjectLength();
}


template <class ToBeSigned>
bool H235_SIGNED<ToBeSigned>::Decode(SAsnStream & strm)
{
  if (!PreambleDecode(strm))
    return false;

  if (!m_toBeSigned.Decode(strm))
    return false;
  if (!m_algorithmOID.Decode(strm))
    return false;
  if (!m_paramS.Decode(strm))
    return false;
  if (!m_signature.Decode(strm))
    return false;

  return UnknownExtensionsDecode(strm);
}


template <class ToBeSigned>
void H235_SIGNED<ToBeSigned>::Encode(SAsnStream & strm) const
{
  PreambleEncode(strm);

  m_toBeSigned.Encode(strm);
  m_algorithmOID.Encode(strm);
  m_paramS.Encode(strm);
  m_signature.Encode(strm);

  UnknownExtensionsEncode(strm);
}


template <class ToBeSigned>
SObject * H235_SIGNED<ToBeSigned>::Clone() const
{
#ifndef SASN_LEANANDMEAN
  SAssert(typeid(H235_SIGNED<ToBeSigned>) == typeid(*this), SInvalidCast);
#endif
  return new H235_SIGNED<ToBeSigned>(*this);
}


//
// ENCRYPTED
//

template <class ToBeEncrypted>
H235_ENCRYPTED<ToBeEncrypted>::H235_ENCRYPTED(unsigned tag, SAsnObject::TagClass tagClass)
  : SAsnSequence(tag, tagClass, 0, false, 0)
{
}


#ifndef SASN_NOPRINTON
template <class ToBeEncrypted>
void H235_ENCRYPTED<ToBeEncrypted>::PrintOn(ostream & strm) const
{
  long long indent = strm.precision() + 2;
  strm << "{\n" << STrace::MultiLinePrefix;
  strm << setw(indent+15) << "algorithmOID = " << setprecision(indent) << m_algorithmOID << '\n' << STrace::MultiLinePrefix;
  strm << setw(indent+9) << "paramS = " << setprecision(indent) << m_paramS << '\n' << STrace::MultiLinePrefix;
  strm << setw(indent+16) << "encryptedData = " << setprecision(indent) << m_encryptedData << '\n' << STrace::MultiLinePrefix;
  strm << setw(indent-1) << "}";
}
#endif


template <class ToBeEncrypted>
SObject::Comparison H235_ENCRYPTED<ToBeEncrypted>::Compare(const SObject & obj) const
{
#ifndef SASN_LEANANDMEAN
  SAssert(typeid(H235_ENCRYPTED<ToBeEncrypted>) == typeid(*this), SInvalidCast);
#endif
  const H235_ENCRYPTED<ToBeEncrypted> & other = (const H235_ENCRYPTED<ToBeEncrypted> &)obj;

  Comparison result;

  if ((result = m_algorithmOID.Compare(other.m_algorithmOID)) != EqualTo)
    return result;
  if ((result = m_paramS.Compare(other.m_paramS)) != EqualTo)
    return result;
  if ((result = m_encryptedData.Compare(other.m_encryptedData)) != EqualTo)
    return result;

  return SAsnSequence::Compare(other);
}


template <class ToBeEncrypted>
int H235_ENCRYPTED<ToBeEncrypted>::GetDataLength() const
{
  return m_algorithmOID.GetObjectLength() +
         m_paramS.GetObjectLength() +
         m_encryptedData.GetObjectLength();
}


template <class ToBeEncrypted>
bool H235_ENCRYPTED<ToBeEncrypted>::Decode(SAsnStream & strm)
{
  if (!PreambleDecode(strm))
    return false;

  if (!m_algorithmOID.Decode(strm))
    return false;
  if (!m_paramS.Decode(strm))
    return false;
  if (!m_encryptedData.Decode(strm))
    return false;

  return UnknownExtensionsDecode(strm);
}


template <class ToBeEncrypted>
void H235_ENCRYPTED<ToBeEncrypted>::Encode(SAsnStream & strm) const
{
  PreambleEncode(strm);

  m_algorithmOID.Encode(strm);
  m_paramS.Encode(strm);
  m_encryptedData.Encode(strm);

  UnknownExtensionsEncode(strm);
}


template <class ToBeEncrypted>
SObject * H235_ENCRYPTED<ToBeEncrypted>::Clone() const
{
#ifndef SASN_LEANANDMEAN
  SAssert(typeid(H235_ENCRYPTED<ToBeEncrypted>) == typeid(*this), SInvalidCast);
#endif
  return new H235_ENCRYPTED<ToBeEncrypted>(*this);
}


//
// HASHED
//

template <class ToBeHashed>
H235_HASHED<ToBeHashed>::H235_HASHED(unsigned tag, SAsnObject::TagClass tagClass)
  : SAsnSequence(tag, tagClass, 0, false, 0)
{
}


#ifndef SASN_NOPRINTON
template <class ToBeHashed>
void H235_HASHED<ToBeHashed>::PrintOn(ostream & strm) const
{
  long long indent = strm.precision() + 2;
  strm << "{\n" << STrace::MultiLinePrefix;
  strm << setw(indent+15) << "algorithmOID = " << setprecision(indent) << m_algorithmOID << '\n' << STrace::MultiLinePrefix;
  strm << setw(indent+9) << "paramS = " << setprecision(indent) << m_paramS << '\n' << STrace::MultiLinePrefix;
  strm << setw(indent+7) << "hash = " << setprecision(indent) << m_hash << '\n' << STrace::MultiLinePrefix;
  strm << setw(indent-1) << "}";
}
#endif


template <class ToBeHashed>
SObject::Comparison H235_HASHED<ToBeHashed>::Compare(const SObject & obj) const
{
#ifndef SASN_LEANANDMEAN
  SAssert(typeid(H235_HASHED<ToBeHashed>) == typeid(*this), SInvalidCast);
#endif
  const H235_HASHED<ToBeHashed> & other = (const H235_HASHED<ToBeHashed> &)obj;

  Comparison result;

  if ((result = m_algorithmOID.Compare(other.m_algorithmOID)) != EqualTo)
    return result;
  if ((result = m_paramS.Compare(other.m_paramS)) != EqualTo)
    return result;
  if ((result = m_hash.Compare(other.m_hash)) != EqualTo)
    return result;

  return SAsnSequence::Compare(other);
}


template <class ToBeHashed>
int H235_HASHED<ToBeHashed>::GetDataLength() const
{
  return m_algorithmOID.GetObjectLength() +
         m_paramS.GetObjectLength() +
         m_hash.GetObjectLength();
}


template <class ToBeHashed>
bool H235_HASHED<ToBeHashed>::Decode(SAsnStream & strm)
{
  if (!PreambleDecode(strm))
    return false;

  if (!m_algorithmOID.Decode(strm))
    return false;
  if (!m_paramS.Decode(strm))
    return false;
  if (!m_hash.Decode(strm))
    return false;

  return UnknownExtensionsDecode(strm);
}


template <class ToBeHashed>
void H235_HASHED<ToBeHashed>::Encode(SAsnStream & strm) const
{
  PreambleEncode(strm);

  m_algorithmOID.Encode(strm);
  m_paramS.Encode(strm);
  m_hash.Encode(strm);

  UnknownExtensionsEncode(strm);
}


template <class ToBeHashed>
SObject * H235_HASHED<ToBeHashed>::Clone() const
{
#ifndef SASN_LEANANDMEAN
  SAssert(typeid(H235_HASHED<ToBeHashed>) == typeid(*this), SInvalidCast);
#endif
  return new H235_HASHED<ToBeHashed>(*this);
}



// End of h235_t.cpp
