//
// h225.h
//
// Code automatically generated by asnparse.
//

#ifndef __H225_H
#define __H225_H

#ifdef __GNUC__
#pragma interface
#endif

#include <stlib.h>

using namespace std;
using namespace Tools;

#include <asner.h>

#include "h235.h"
#include "h245.h"


//
// ReleaseCompleteReason
//

class H225_NonStandardParameter;
class H225_ConferenceIdentifier;

class H225_ReleaseCompleteReason : public SAsnChoice
{
  public:
    H225_ReleaseCompleteReason(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_noBandwidth,
      e_gatekeeperResources,
      e_unreachableDestination,
      e_destinationRejection,
      e_invalidRevision,
      e_noPermission,
      e_unreachableGatekeeper,
      e_gatewayResources,
      e_badFormatAddress,
      e_adaptiveBusy,
      e_inConf,
      e_undefinedReason,
      e_facilityCallDeflection,
      e_securityDenied,
      e_calledPartyNotRegistered,
      e_callerNotRegistered,
      e_newConnectionNeeded,
      e_nonStandardReason,
      e_replaceWithConferenceInvite,
      e_genericDataReason,
      e_neededFeatureNotSupported,
      e_tunnelledSignallingRejected,
      e_invalidCID
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_NonStandardParameter &() const;
#else
    operator H225_NonStandardParameter &();
    operator const H225_NonStandardParameter &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_ConferenceIdentifier &() const;
#else
    operator H225_ConferenceIdentifier &();
    operator const H225_ConferenceIdentifier &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// ScnConnectionType
//

class H225_ScnConnectionType : public SAsnChoice
{
  public:
    H225_ScnConnectionType(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_unknown,
      e_bChannel,
      e_hybrid2x64,
      e_hybrid384,
      e_hybrid1536,
      e_hybrid1920,
      e_multirate
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// ScnConnectionAggregation
//

class H225_ScnConnectionAggregation : public SAsnChoice
{
  public:
    H225_ScnConnectionAggregation(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_auto,
      e_none,
      e_h221,
      e_bonded_mode1,
      e_bonded_mode2,
      e_bonded_mode3
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// PresentationIndicator
//

class H225_PresentationIndicator : public SAsnChoice
{
  public:
    H225_PresentationIndicator(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_presentationAllowed,
      e_presentationRestricted,
      e_addressNotAvailable
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// ScreeningIndicator
//

class H225_ScreeningIndicator : public SAsnEnumeration
{
  public:
    H225_ScreeningIndicator(unsigned tag = UniversalEnumeration, TagClass tagClass = UniversalTagClass);

    enum Enumerations {
      e_userProvidedNotScreened,
      e_userProvidedVerifiedAndPassed,
      e_userProvidedVerifiedAndFailed,
      e_networkProvided
    };

    H225_ScreeningIndicator & operator=(unsigned v);
    SObject * Clone() const;
};


//
// FacilityReason
//

class H225_FacilityReason : public SAsnChoice
{
  public:
    H225_FacilityReason(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_routeCallToGatekeeper,
      e_callForwarded,
      e_routeCallToMC,
      e_undefinedReason,
      e_conferenceListChoice,
      e_startH245,
      e_noH245,
      e_newTokens,
      e_featureSetUpdate,
      e_forwardedElements,
      e_transportedInformation
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// TransportAddress
//

class H225_TransportAddress_ipAddress;
class H225_TransportAddress_ipSourceRoute;
class H225_TransportAddress_ipxAddress;
class H225_TransportAddress_ip6Address;
class H225_NonStandardParameter;

class H225_TransportAddress : public SAsnChoice
{
  public:
    H225_TransportAddress(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_ipAddress,
      e_ipSourceRoute,
      e_ipxAddress,
      e_ip6Address,
      e_netBios,
      e_nsap,
      e_nonStandardAddress
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_TransportAddress_ipAddress &() const;
#else
    operator H225_TransportAddress_ipAddress &();
    operator const H225_TransportAddress_ipAddress &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_TransportAddress_ipSourceRoute &() const;
#else
    operator H225_TransportAddress_ipSourceRoute &();
    operator const H225_TransportAddress_ipSourceRoute &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_TransportAddress_ipxAddress &() const;
#else
    operator H225_TransportAddress_ipxAddress &();
    operator const H225_TransportAddress_ipxAddress &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_TransportAddress_ip6Address &() const;
#else
    operator H225_TransportAddress_ip6Address &();
    operator const H225_TransportAddress_ip6Address &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_NonStandardParameter &() const;
#else
    operator H225_NonStandardParameter &();
    operator const H225_NonStandardParameter &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// SupportedProtocols
//

class H225_NonStandardParameter;
class H225_H310Caps;
class H225_H320Caps;
class H225_H321Caps;
class H225_H322Caps;
class H225_H323Caps;
class H225_H324Caps;
class H225_VoiceCaps;
class H225_T120OnlyCaps;
class H225_NonStandardProtocol;
class H225_T38FaxAnnexbOnlyCaps;

class H225_SupportedProtocols : public SAsnChoice
{
  public:
    H225_SupportedProtocols(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_nonStandardData,
      e_h310,
      e_h320,
      e_h321,
      e_h322,
      e_h323,
      e_h324,
      e_voice,
      e_t120_only,
      e_nonStandardProtocol,
      e_t38FaxAnnexbOnly
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_NonStandardParameter &() const;
#else
    operator H225_NonStandardParameter &();
    operator const H225_NonStandardParameter &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_H310Caps &() const;
#else
    operator H225_H310Caps &();
    operator const H225_H310Caps &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_H320Caps &() const;
#else
    operator H225_H320Caps &();
    operator const H225_H320Caps &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_H321Caps &() const;
#else
    operator H225_H321Caps &();
    operator const H225_H321Caps &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_H322Caps &() const;
#else
    operator H225_H322Caps &();
    operator const H225_H322Caps &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_H323Caps &() const;
#else
    operator H225_H323Caps &();
    operator const H225_H323Caps &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_H324Caps &() const;
#else
    operator H225_H324Caps &();
    operator const H225_H324Caps &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_VoiceCaps &() const;
#else
    operator H225_VoiceCaps &();
    operator const H225_VoiceCaps &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_T120OnlyCaps &() const;
#else
    operator H225_T120OnlyCaps &();
    operator const H225_T120OnlyCaps &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_NonStandardProtocol &() const;
#else
    operator H225_NonStandardProtocol &();
    operator const H225_NonStandardProtocol &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_T38FaxAnnexbOnlyCaps &() const;
#else
    operator H225_T38FaxAnnexbOnlyCaps &();
    operator const H225_T38FaxAnnexbOnlyCaps &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// H221NonStandard
//

class H225_H221NonStandard : public SAsnSequence
{
  public:
    H225_H221NonStandard(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnInteger m_t35CountryCode;
    SAsnInteger m_t35Extension;
    SAsnInteger m_manufacturerCode;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// TunnelledProtocolAlternateIdentifier
//

class H225_TunnelledProtocolAlternateIdentifier : public SAsnSequence
{
  public:
    H225_TunnelledProtocolAlternateIdentifier(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_protocolVariant
    };

    SAsnIA5String m_protocolType;
    SAsnIA5String m_protocolVariant;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// NonStandardIdentifier
//

class H225_H221NonStandard;

class H225_NonStandardIdentifier : public SAsnChoice
{
  public:
    H225_NonStandardIdentifier(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_object,
      e_h221NonStandard
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_H221NonStandard &() const;
#else
    operator H225_H221NonStandard &();
    operator const H225_H221NonStandard &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// AliasAddress
//

class H225_TransportAddress;
class H225_PartyNumber;
class H225_MobileUIM;

class H225_AliasAddress : public SAsnChoice
{
  public:
    H225_AliasAddress(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_dialedDigits,
      e_h323_ID,
      e_url_ID,
      e_transportID,
      e_email_ID,
      e_partyNumber,
      e_mobileUIM
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_TransportAddress &() const;
#else
    operator H225_TransportAddress &();
    operator const H225_TransportAddress &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_PartyNumber &() const;
#else
    operator H225_PartyNumber &();
    operator const H225_PartyNumber &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_MobileUIM &() const;
#else
    operator H225_MobileUIM &();
    operator const H225_MobileUIM &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// AddressPattern
//

class H225_AliasAddress;
class H225_AddressPattern_range;

class H225_AddressPattern : public SAsnChoice
{
  public:
    H225_AddressPattern(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_wildcard,
      e_range
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_AliasAddress &() const;
#else
    operator H225_AliasAddress &();
    operator const H225_AliasAddress &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_AddressPattern_range &() const;
#else
    operator H225_AddressPattern_range &();
    operator const H225_AddressPattern_range &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// PartyNumber
//

class H225_PublicPartyNumber;
class H225_NumberDigits;
class H225_NumberDigits;
class H225_PrivatePartyNumber;
class H225_NumberDigits;

class H225_PartyNumber : public SAsnChoice
{
  public:
    H225_PartyNumber(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_e164Number,
      e_dataPartyNumber,
      e_telexPartyNumber,
      e_privateNumber,
      e_nationalStandardPartyNumber
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_PublicPartyNumber &() const;
#else
    operator H225_PublicPartyNumber &();
    operator const H225_PublicPartyNumber &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_NumberDigits &() const;
#else
    operator H225_NumberDigits &();
    operator const H225_NumberDigits &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_PrivatePartyNumber &() const;
#else
    operator H225_PrivatePartyNumber &();
    operator const H225_PrivatePartyNumber &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// NumberDigits
//

class H225_NumberDigits : public SAsnIA5String
{
  public:
    H225_NumberDigits(unsigned tag = UniversalIA5String, TagClass tagClass = UniversalTagClass);

    H225_NumberDigits & operator=(const char * v);
    H225_NumberDigits & operator=(const SString & v);
    SObject * Clone() const;
};


//
// PublicTypeOfNumber
//

class H225_PublicTypeOfNumber : public SAsnChoice
{
  public:
    H225_PublicTypeOfNumber(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_unknown,
      e_internationalNumber,
      e_nationalNumber,
      e_networkSpecificNumber,
      e_subscriberNumber,
      e_abbreviatedNumber
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// PrivateTypeOfNumber
//

class H225_PrivateTypeOfNumber : public SAsnChoice
{
  public:
    H225_PrivateTypeOfNumber(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_unknown,
      e_level2RegionalNumber,
      e_level1RegionalNumber,
      e_pISNSpecificNumber,
      e_localNumber,
      e_abbreviatedNumber
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// MobileUIM
//

class H225_ANSI_41_UIM;
class H225_GSM_UIM;

class H225_MobileUIM : public SAsnChoice
{
  public:
    H225_MobileUIM(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_ansi_41_uim,
      e_gsm_uim
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_ANSI_41_UIM &() const;
#else
    operator H225_ANSI_41_UIM &();
    operator const H225_ANSI_41_UIM &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_GSM_UIM &() const;
#else
    operator H225_GSM_UIM &();
    operator const H225_GSM_UIM &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// TBCD-STRING
//

class H225_TBCD_STRING : public SAsnIA5String
{
  public:
    H225_TBCD_STRING(unsigned tag = UniversalIA5String, TagClass tagClass = UniversalTagClass);

    H225_TBCD_STRING & operator=(const char * v);
    H225_TBCD_STRING & operator=(const SString & v);
    SObject * Clone() const;
};


//
// GSM-UIM
//

class H225_GSM_UIM : public SAsnSequence
{
  public:
    H225_GSM_UIM(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_imsi,
      e_tmsi,
      e_msisdn,
      e_imei,
      e_hplmn,
      e_vplmn
    };

    SAsnIA5String m_imsi;
    SAsnOctetString m_tmsi;
    SAsnIA5String m_msisdn;
    SAsnIA5String m_imei;
    SAsnIA5String m_hplmn;
    SAsnIA5String m_vplmn;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// ExtendedAliasAddress
//

class H225_ExtendedAliasAddress : public SAsnSequence
{
  public:
    H225_ExtendedAliasAddress(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_presentationIndicator,
      e_screeningIndicator
    };

    H225_AliasAddress m_address;
    H225_PresentationIndicator m_presentationIndicator;
    H225_ScreeningIndicator m_screeningIndicator;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// UseSpecifiedTransport
//

class H225_UseSpecifiedTransport : public SAsnChoice
{
  public:
    H225_UseSpecifiedTransport(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_tcp,
      e_annexE
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// SecurityServiceMode
//

class H225_NonStandardParameter;

class H225_SecurityServiceMode : public SAsnChoice
{
  public:
    H225_SecurityServiceMode(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_nonStandard,
      e_none,
      e_default
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_NonStandardParameter &() const;
#else
    operator H225_NonStandardParameter &();
    operator const H225_NonStandardParameter &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// H245Security
//

class H225_NonStandardParameter;
class H225_SecurityCapabilities;
class H225_SecurityCapabilities;

class H225_H245Security : public SAsnChoice
{
  public:
    H225_H245Security(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_nonStandard,
      e_noSecurity,
      e_tls,
      e_ipsec
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_NonStandardParameter &() const;
#else
    operator H225_NonStandardParameter &();
    operator const H225_NonStandardParameter &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_SecurityCapabilities &() const;
#else
    operator H225_SecurityCapabilities &();
    operator const H225_SecurityCapabilities &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// Q954Details
//

class H225_Q954Details : public SAsnSequence
{
  public:
    H225_Q954Details(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnBoolean m_conferenceCalling;
    SAsnBoolean m_threePartyService;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// GloballyUniqueID
//

class H225_GloballyUniqueID : public SAsnOctetString
{
  public:
    H225_GloballyUniqueID(unsigned tag = UniversalOctetString, TagClass tagClass = UniversalTagClass);

    H225_GloballyUniqueID & operator=(const char * v);
    H225_GloballyUniqueID & operator=(const SString & v);
    H225_GloballyUniqueID & operator=(const std::vector<BYTE> & v);
    SObject * Clone() const;
};


//
// ConferenceIdentifier
//

class H225_ConferenceIdentifier : public H225_GloballyUniqueID
{
  public:
    H225_ConferenceIdentifier(unsigned tag = UniversalOctetString, TagClass tagClass = UniversalTagClass);

    H225_ConferenceIdentifier & operator=(const char * v);
    H225_ConferenceIdentifier & operator=(const SString & v);
    H225_ConferenceIdentifier & operator=(const std::vector<BYTE> & v);
    SObject * Clone() const;
};


//
// RequestSeqNum
//

class H225_RequestSeqNum : public SAsnInteger
{
  public:
    H225_RequestSeqNum(unsigned tag = UniversalInteger, TagClass tagClass = UniversalTagClass);

    H225_RequestSeqNum & operator=(int v);
    H225_RequestSeqNum & operator=(unsigned v);
    SObject * Clone() const;
};


//
// GatekeeperIdentifier
//

class H225_GatekeeperIdentifier : public SAsnBmpString
{
  public:
    H225_GatekeeperIdentifier(unsigned tag = UniversalBmpString, TagClass tagClass = UniversalTagClass);

    H225_GatekeeperIdentifier & operator=(const char * v);
    H225_GatekeeperIdentifier & operator=(const SString & v);
    SObject * Clone() const;
};


//
// BandWidth
//

class H225_BandWidth : public SAsnInteger
{
  public:
    H225_BandWidth(unsigned tag = UniversalInteger, TagClass tagClass = UniversalTagClass);

    H225_BandWidth & operator=(int v);
    H225_BandWidth & operator=(unsigned v);
    SObject * Clone() const;
};


//
// CallReferenceValue
//

class H225_CallReferenceValue : public SAsnInteger
{
  public:
    H225_CallReferenceValue(unsigned tag = UniversalInteger, TagClass tagClass = UniversalTagClass);

    H225_CallReferenceValue & operator=(int v);
    H225_CallReferenceValue & operator=(unsigned v);
    SObject * Clone() const;
};


//
// EndpointIdentifier
//

class H225_EndpointIdentifier : public SAsnBmpString
{
  public:
    H225_EndpointIdentifier(unsigned tag = UniversalBmpString, TagClass tagClass = UniversalTagClass);

    H225_EndpointIdentifier & operator=(const char * v);
    H225_EndpointIdentifier & operator=(const SString & v);
    SObject * Clone() const;
};


//
// ProtocolIdentifier
//

class H225_ProtocolIdentifier : public SAsnObjectId
{
  public:
    H225_ProtocolIdentifier(unsigned tag = UniversalObjectId, TagClass tagClass = UniversalTagClass);

    SObject * Clone() const;
};


//
// TimeToLive
//

class H225_TimeToLive : public SAsnInteger
{
  public:
    H225_TimeToLive(unsigned tag = UniversalInteger, TagClass tagClass = UniversalTagClass);

    H225_TimeToLive & operator=(int v);
    H225_TimeToLive & operator=(unsigned v);
    SObject * Clone() const;
};


//
// H248PackagesDescriptor
//

class H225_H248PackagesDescriptor : public SAsnOctetString
{
  public:
    H225_H248PackagesDescriptor(unsigned tag = UniversalOctetString, TagClass tagClass = UniversalTagClass);

    H225_H248PackagesDescriptor & operator=(const char * v);
    H225_H248PackagesDescriptor & operator=(const SString & v);
    H225_H248PackagesDescriptor & operator=(const std::vector<BYTE> & v);
    SObject * Clone() const;
};


//
// H248SignalsDescriptor
//

class H225_H248SignalsDescriptor : public SAsnOctetString
{
  public:
    H225_H248SignalsDescriptor(unsigned tag = UniversalOctetString, TagClass tagClass = UniversalTagClass);

    H225_H248SignalsDescriptor & operator=(const char * v);
    H225_H248SignalsDescriptor & operator=(const SString & v);
    H225_H248SignalsDescriptor & operator=(const std::vector<BYTE> & v);
    SObject * Clone() const;
};


//
// CallIdentifier
//

class H225_CallIdentifier : public SAsnSequence
{
  public:
    H225_CallIdentifier(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    H225_GloballyUniqueID m_guid;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// EncryptIntAlg
//

class H225_NonStandardParameter;

class H225_EncryptIntAlg : public SAsnChoice
{
  public:
    H225_EncryptIntAlg(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_nonStandard,
      e_isoAlgorithm
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_NonStandardParameter &() const;
#else
    operator H225_NonStandardParameter &();
    operator const H225_NonStandardParameter &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// NonIsoIntegrityMechanism
//

class H225_EncryptIntAlg;
class H225_EncryptIntAlg;

class H225_NonIsoIntegrityMechanism : public SAsnChoice
{
  public:
    H225_NonIsoIntegrityMechanism(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_hMAC_MD5,
      e_hMAC_iso10118_2_s,
      e_hMAC_iso10118_2_l,
      e_hMAC_iso10118_3
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_EncryptIntAlg &() const;
#else
    operator H225_EncryptIntAlg &();
    operator const H225_EncryptIntAlg &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// IntegrityMechanism
//

class H225_NonStandardParameter;
class H225_NonIsoIntegrityMechanism;

class H225_IntegrityMechanism : public SAsnChoice
{
  public:
    H225_IntegrityMechanism(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_nonStandard,
      e_digSig,
      e_iso9797,
      e_nonIsoIM
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_NonStandardParameter &() const;
#else
    operator H225_NonStandardParameter &();
    operator const H225_NonStandardParameter &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_NonIsoIntegrityMechanism &() const;
#else
    operator H225_NonIsoIntegrityMechanism &();
    operator const H225_NonIsoIntegrityMechanism &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// ICV
//

class H225_ICV : public SAsnSequence
{
  public:
    H225_ICV(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObjectId m_algorithmOID;
    SAsnBitString m_icv;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// FastStartToken
//

class H225_FastStartToken : public H235_ClearToken
{
  public:
    H225_FastStartToken(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    SObject * Clone() const;
};


//
// EncodedFastStartToken
//

typedef H225_FastStartToken H225_EncodedFastStartToken;


//
// CryptoH323Token
//

class H225_CryptoH323Token_cryptoEPPwdHash;
class H225_CryptoH323Token_cryptoGKPwdHash;
class H235_CryptoToken;

class H225_CryptoH323Token : public SAsnChoice
{
  public:
    H225_CryptoH323Token(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_cryptoEPPwdHash,
      e_cryptoGKPwdHash,
      e_cryptoEPPwdEncr,
      e_cryptoGKPwdEncr,
      e_cryptoEPCert,
      e_cryptoGKCert,
      e_cryptoFastStart,
      e_nestedcryptoToken
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_CryptoH323Token_cryptoEPPwdHash &() const;
#else
    operator H225_CryptoH323Token_cryptoEPPwdHash &();
    operator const H225_CryptoH323Token_cryptoEPPwdHash &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_CryptoH323Token_cryptoGKPwdHash &() const;
#else
    operator H225_CryptoH323Token_cryptoGKPwdHash &();
    operator const H225_CryptoH323Token_cryptoGKPwdHash &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H235_ENCRYPTED<H235_EncodedPwdCertToken> &() const;
#else
    operator H235_ENCRYPTED<H235_EncodedPwdCertToken> &();
    operator const H235_ENCRYPTED<H235_EncodedPwdCertToken> &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H235_SIGNED<H235_EncodedPwdCertToken> &() const;
#else
    operator H235_SIGNED<H235_EncodedPwdCertToken> &();
    operator const H235_SIGNED<H235_EncodedPwdCertToken> &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H235_SIGNED<H225_EncodedFastStartToken> &() const;
#else
    operator H235_SIGNED<H225_EncodedFastStartToken> &();
    operator const H235_SIGNED<H225_EncodedFastStartToken> &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H235_CryptoToken &() const;
#else
    operator H235_CryptoToken &();
    operator const H235_CryptoToken &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// CallLinkage
//

class H225_CallLinkage : public SAsnSequence
{
  public:
    H225_CallLinkage(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_globalCallId,
      e_threadId
    };

    H225_GloballyUniqueID m_globalCallId;
    H225_GloballyUniqueID m_threadId;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// CapacityReportingCapability
//

class H225_CapacityReportingCapability : public SAsnSequence
{
  public:
    H225_CapacityReportingCapability(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnBoolean m_canReportCallCapacity;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// CallsAvailable
//

class H225_CallsAvailable : public SAsnSequence
{
  public:
    H225_CallsAvailable(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_group
    };

    SAsnInteger m_calls;
    SAsnIA5String m_group;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// ServiceControlDescriptor
//

class H225_H248SignalsDescriptor;
class H225_NonStandardParameter;
class H225_CallCreditServiceControl;

class H225_ServiceControlDescriptor : public SAsnChoice
{
  public:
    H225_ServiceControlDescriptor(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_url,
      e_signal,
      e_nonStandard,
      e_callCreditServiceControl
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_H248SignalsDescriptor &() const;
#else
    operator H225_H248SignalsDescriptor &();
    operator const H225_H248SignalsDescriptor &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_NonStandardParameter &() const;
#else
    operator H225_NonStandardParameter &();
    operator const H225_NonStandardParameter &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_CallCreditServiceControl &() const;
#else
    operator H225_CallCreditServiceControl &();
    operator const H225_CallCreditServiceControl &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// CallTerminationCause
//

class H225_ReleaseCompleteReason;

class H225_CallTerminationCause : public SAsnChoice
{
  public:
    H225_CallTerminationCause(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_releaseCompleteReason,
      e_releaseCompleteCauseIE
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_ReleaseCompleteReason &() const;
#else
    operator H225_ReleaseCompleteReason &();
    operator const H225_ReleaseCompleteReason &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// CallCreditCapability
//

class H225_CallCreditCapability : public SAsnSequence
{
  public:
    H225_CallCreditCapability(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_canDisplayAmountString,
      e_canEnforceDurationLimit
    };

    SAsnBoolean m_canDisplayAmountString;
    SAsnBoolean m_canEnforceDurationLimit;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// GenericIdentifier
//

class H225_GloballyUniqueID;

class H225_GenericIdentifier : public SAsnChoice
{
  public:
    H225_GenericIdentifier(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_standard,
      e_oid,
      e_nonStandard
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_GloballyUniqueID &() const;
#else
    operator H225_GloballyUniqueID &();
    operator const H225_GloballyUniqueID &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// Content
//

class H225_GenericIdentifier;
class H225_AliasAddress;
class H225_TransportAddress;
class H225_ArrayOf_EnumeratedParameter;
class H225_ArrayOf_GenericData;

class H225_Content : public SAsnChoice
{
  public:
    H225_Content(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_raw,
      e_text,
      e_unicode,
      e_bool,
      e_number8,
      e_number16,
      e_number32,
      e_id,
      e_alias,
      e_transport,
      e_compound,
      e_nested
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_GenericIdentifier &() const;
#else
    operator H225_GenericIdentifier &();
    operator const H225_GenericIdentifier &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_AliasAddress &() const;
#else
    operator H225_AliasAddress &();
    operator const H225_AliasAddress &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_TransportAddress &() const;
#else
    operator H225_TransportAddress &();
    operator const H225_TransportAddress &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_ArrayOf_EnumeratedParameter &() const;
#else
    operator H225_ArrayOf_EnumeratedParameter &();
    operator const H225_ArrayOf_EnumeratedParameter &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_ArrayOf_GenericData &() const;
#else
    operator H225_ArrayOf_GenericData &();
    operator const H225_ArrayOf_GenericData &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// TransportChannelInfo
//

class H225_TransportChannelInfo : public SAsnSequence
{
  public:
    H225_TransportChannelInfo(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_sendAddress,
      e_recvAddress
    };

    H225_TransportAddress m_sendAddress;
    H225_TransportAddress m_recvAddress;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// RasMessage
//

class H225_GatekeeperRequest;
class H225_GatekeeperConfirm;
class H225_GatekeeperReject;
class H225_RegistrationRequest;
class H225_RegistrationConfirm;
class H225_RegistrationReject;
class H225_UnregistrationRequest;
class H225_UnregistrationConfirm;
class H225_UnregistrationReject;
class H225_AdmissionRequest;
class H225_AdmissionConfirm;
class H225_AdmissionReject;
class H225_BandwidthRequest;
class H225_BandwidthConfirm;
class H225_BandwidthReject;
class H225_DisengageRequest;
class H225_DisengageConfirm;
class H225_DisengageReject;
class H225_LocationRequest;
class H225_LocationConfirm;
class H225_LocationReject;
class H225_InfoRequest;
class H225_InfoRequestResponse;
class H225_NonStandardMessage;
class H225_UnknownMessageResponse;
class H225_RequestInProgress;
class H225_ResourcesAvailableIndicate;
class H225_ResourcesAvailableConfirm;
class H225_InfoRequestAck;
class H225_InfoRequestNak;
class H225_ServiceControlIndication;
class H225_ServiceControlResponse;

class H225_RasMessage : public SAsnChoice
{
  public:
    H225_RasMessage(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_gatekeeperRequest,
      e_gatekeeperConfirm,
      e_gatekeeperReject,
      e_registrationRequest,
      e_registrationConfirm,
      e_registrationReject,
      e_unregistrationRequest,
      e_unregistrationConfirm,
      e_unregistrationReject,
      e_admissionRequest,
      e_admissionConfirm,
      e_admissionReject,
      e_bandwidthRequest,
      e_bandwidthConfirm,
      e_bandwidthReject,
      e_disengageRequest,
      e_disengageConfirm,
      e_disengageReject,
      e_locationRequest,
      e_locationConfirm,
      e_locationReject,
      e_infoRequest,
      e_infoRequestResponse,
      e_nonStandardMessage,
      e_unknownMessageResponse,
      e_requestInProgress,
      e_resourcesAvailableIndicate,
      e_resourcesAvailableConfirm,
      e_infoRequestAck,
      e_infoRequestNak,
      e_serviceControlIndication,
      e_serviceControlResponse
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_GatekeeperRequest &() const;
#else
    operator H225_GatekeeperRequest &();
    operator const H225_GatekeeperRequest &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_GatekeeperConfirm &() const;
#else
    operator H225_GatekeeperConfirm &();
    operator const H225_GatekeeperConfirm &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_GatekeeperReject &() const;
#else
    operator H225_GatekeeperReject &();
    operator const H225_GatekeeperReject &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_RegistrationRequest &() const;
#else
    operator H225_RegistrationRequest &();
    operator const H225_RegistrationRequest &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_RegistrationConfirm &() const;
#else
    operator H225_RegistrationConfirm &();
    operator const H225_RegistrationConfirm &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_RegistrationReject &() const;
#else
    operator H225_RegistrationReject &();
    operator const H225_RegistrationReject &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_UnregistrationRequest &() const;
#else
    operator H225_UnregistrationRequest &();
    operator const H225_UnregistrationRequest &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_UnregistrationConfirm &() const;
#else
    operator H225_UnregistrationConfirm &();
    operator const H225_UnregistrationConfirm &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_UnregistrationReject &() const;
#else
    operator H225_UnregistrationReject &();
    operator const H225_UnregistrationReject &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_AdmissionRequest &() const;
#else
    operator H225_AdmissionRequest &();
    operator const H225_AdmissionRequest &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_AdmissionConfirm &() const;
#else
    operator H225_AdmissionConfirm &();
    operator const H225_AdmissionConfirm &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_AdmissionReject &() const;
#else
    operator H225_AdmissionReject &();
    operator const H225_AdmissionReject &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_BandwidthRequest &() const;
#else
    operator H225_BandwidthRequest &();
    operator const H225_BandwidthRequest &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_BandwidthConfirm &() const;
#else
    operator H225_BandwidthConfirm &();
    operator const H225_BandwidthConfirm &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_BandwidthReject &() const;
#else
    operator H225_BandwidthReject &();
    operator const H225_BandwidthReject &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_DisengageRequest &() const;
#else
    operator H225_DisengageRequest &();
    operator const H225_DisengageRequest &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_DisengageConfirm &() const;
#else
    operator H225_DisengageConfirm &();
    operator const H225_DisengageConfirm &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_DisengageReject &() const;
#else
    operator H225_DisengageReject &();
    operator const H225_DisengageReject &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_LocationRequest &() const;
#else
    operator H225_LocationRequest &();
    operator const H225_LocationRequest &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_LocationConfirm &() const;
#else
    operator H225_LocationConfirm &();
    operator const H225_LocationConfirm &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_LocationReject &() const;
#else
    operator H225_LocationReject &();
    operator const H225_LocationReject &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_InfoRequest &() const;
#else
    operator H225_InfoRequest &();
    operator const H225_InfoRequest &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_InfoRequestResponse &() const;
#else
    operator H225_InfoRequestResponse &();
    operator const H225_InfoRequestResponse &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_NonStandardMessage &() const;
#else
    operator H225_NonStandardMessage &();
    operator const H225_NonStandardMessage &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_UnknownMessageResponse &() const;
#else
    operator H225_UnknownMessageResponse &();
    operator const H225_UnknownMessageResponse &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_RequestInProgress &() const;
#else
    operator H225_RequestInProgress &();
    operator const H225_RequestInProgress &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_ResourcesAvailableIndicate &() const;
#else
    operator H225_ResourcesAvailableIndicate &();
    operator const H225_ResourcesAvailableIndicate &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_ResourcesAvailableConfirm &() const;
#else
    operator H225_ResourcesAvailableConfirm &();
    operator const H225_ResourcesAvailableConfirm &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_InfoRequestAck &() const;
#else
    operator H225_InfoRequestAck &();
    operator const H225_InfoRequestAck &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_InfoRequestNak &() const;
#else
    operator H225_InfoRequestNak &();
    operator const H225_InfoRequestNak &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_ServiceControlIndication &() const;
#else
    operator H225_ServiceControlIndication &();
    operator const H225_ServiceControlIndication &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_ServiceControlResponse &() const;
#else
    operator H225_ServiceControlResponse &();
    operator const H225_ServiceControlResponse &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// GatekeeperRejectReason
//

class H225_GatekeeperRejectReason : public SAsnChoice
{
  public:
    H225_GatekeeperRejectReason(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_resourceUnavailable,
      e_terminalExcluded,
      e_invalidRevision,
      e_undefinedReason,
      e_securityDenial,
      e_genericDataReason,
      e_neededFeatureNotSupported
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// RegistrationRejectReason
//

class H225_ArrayOf_AliasAddress;
class H225_RegistrationRejectReason_invalidTerminalAliases;

class H225_RegistrationRejectReason : public SAsnChoice
{
  public:
    H225_RegistrationRejectReason(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_discoveryRequired,
      e_invalidRevision,
      e_invalidCallSignalAddress,
      e_invalidRASAddress,
      e_duplicateAlias,
      e_invalidTerminalType,
      e_undefinedReason,
      e_transportNotSupported,
      e_transportQOSNotSupported,
      e_resourceUnavailable,
      e_invalidAlias,
      e_securityDenial,
      e_fullRegistrationRequired,
      e_additiveRegistrationNotSupported,
      e_invalidTerminalAliases,
      e_genericDataReason,
      e_neededFeatureNotSupported
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_ArrayOf_AliasAddress &() const;
#else
    operator H225_ArrayOf_AliasAddress &();
    operator const H225_ArrayOf_AliasAddress &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_RegistrationRejectReason_invalidTerminalAliases &() const;
#else
    operator H225_RegistrationRejectReason_invalidTerminalAliases &();
    operator const H225_RegistrationRejectReason_invalidTerminalAliases &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// UnregRequestReason
//

class H225_UnregRequestReason : public SAsnChoice
{
  public:
    H225_UnregRequestReason(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_reregistrationRequired,
      e_ttlExpired,
      e_securityDenial,
      e_undefinedReason,
      e_maintenance
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// UnregRejectReason
//

class H225_UnregRejectReason : public SAsnChoice
{
  public:
    H225_UnregRejectReason(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_notCurrentlyRegistered,
      e_callInProgress,
      e_undefinedReason,
      e_permissionDenied,
      e_securityDenial
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// CallType
//

class H225_CallType : public SAsnChoice
{
  public:
    H225_CallType(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_pointToPoint,
      e_oneToN,
      e_nToOne,
      e_nToN
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// CallModel
//

class H225_CallModel : public SAsnChoice
{
  public:
    H225_CallModel(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_direct,
      e_gatekeeperRouted
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// TransportQOS
//

class H225_TransportQOS : public SAsnChoice
{
  public:
    H225_TransportQOS(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_endpointControlled,
      e_gatekeeperControlled,
      e_noControl
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// UUIEsRequested
//

class H225_UUIEsRequested : public SAsnSequence
{
  public:
    H225_UUIEsRequested(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_status,
      e_statusInquiry,
      e_setupAcknowledge,
      e_notify
    };

    SAsnBoolean m_setup;
    SAsnBoolean m_callProceeding;
    SAsnBoolean m_connect;
    SAsnBoolean m_alerting;
    SAsnBoolean m_information;
    SAsnBoolean m_releaseComplete;
    SAsnBoolean m_facility;
    SAsnBoolean m_progress;
    SAsnBoolean m_empty;
    SAsnBoolean m_status;
    SAsnBoolean m_statusInquiry;
    SAsnBoolean m_setupAcknowledge;
    SAsnBoolean m_notify;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// AdmissionRejectReason
//

class H225_ArrayOf_PartyNumber;

class H225_AdmissionRejectReason : public SAsnChoice
{
  public:
    H225_AdmissionRejectReason(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_calledPartyNotRegistered,
      e_invalidPermission,
      e_requestDenied,
      e_undefinedReason,
      e_callerNotRegistered,
      e_routeCallToGatekeeper,
      e_invalidEndpointIdentifier,
      e_resourceUnavailable,
      e_securityDenial,
      e_qosControlNotSupported,
      e_incompleteAddress,
      e_aliasesInconsistent,
      e_routeCallToSCN,
      e_exceedsCallCapacity,
      e_collectDestination,
      e_collectPIN,
      e_genericDataReason,
      e_neededFeatureNotSupported
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_ArrayOf_PartyNumber &() const;
#else
    operator H225_ArrayOf_PartyNumber &();
    operator const H225_ArrayOf_PartyNumber &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// BandRejectReason
//

class H225_BandRejectReason : public SAsnChoice
{
  public:
    H225_BandRejectReason(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_notBound,
      e_invalidConferenceID,
      e_invalidPermission,
      e_insufficientResources,
      e_invalidRevision,
      e_undefinedReason,
      e_securityDenial
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// LocationRejectReason
//

class H225_ArrayOf_PartyNumber;

class H225_LocationRejectReason : public SAsnChoice
{
  public:
    H225_LocationRejectReason(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_notRegistered,
      e_invalidPermission,
      e_requestDenied,
      e_undefinedReason,
      e_securityDenial,
      e_aliasesInconsistent,
      e_routeCalltoSCN,
      e_resourceUnavailable,
      e_genericDataReason,
      e_neededFeatureNotSupported,
      e_hopCountExceeded,
      e_incompleteAddress
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_ArrayOf_PartyNumber &() const;
#else
    operator H225_ArrayOf_PartyNumber &();
    operator const H225_ArrayOf_PartyNumber &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// DisengageReason
//

class H225_DisengageReason : public SAsnChoice
{
  public:
    H225_DisengageReason(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_forcedDrop,
      e_normalDrop,
      e_undefinedReason
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// DisengageRejectReason
//

class H225_DisengageRejectReason : public SAsnChoice
{
  public:
    H225_DisengageRejectReason(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_notRegistered,
      e_requestToDropOther,
      e_securityDenial
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// InfoRequestResponseStatus
//

class H225_InfoRequestResponseStatus : public SAsnChoice
{
  public:
    H225_InfoRequestResponseStatus(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_complete,
      e_incomplete,
      e_segment,
      e_invalidCall
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// InfoRequestNakReason
//

class H225_InfoRequestNakReason : public SAsnChoice
{
  public:
    H225_InfoRequestNakReason(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_notRegistered,
      e_securityDenial,
      e_undefinedReason
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// H323-UserInformation_user-data
//

class H225_H323_UserInformation_user_data : public SAsnSequence
{
  public:
    H225_H323_UserInformation_user_data(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnInteger m_protocol_discriminator;
    SAsnOctetString m_user_information;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// H323-UU-PDU_h323-message-body
//

class H225_Setup_UUIE;
class H225_CallProceeding_UUIE;
class H225_Connect_UUIE;
class H225_Alerting_UUIE;
class H225_Information_UUIE;
class H225_ReleaseComplete_UUIE;
class H225_Facility_UUIE;
class H225_Progress_UUIE;
class H225_Status_UUIE;
class H225_StatusInquiry_UUIE;
class H225_SetupAcknowledge_UUIE;
class H225_Notify_UUIE;

class H225_H323_UU_PDU_h323_message_body : public SAsnChoice
{
  public:
    H225_H323_UU_PDU_h323_message_body(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_setup,
      e_callProceeding,
      e_connect,
      e_alerting,
      e_information,
      e_releaseComplete,
      e_facility,
      e_progress,
      e_empty,
      e_status,
      e_statusInquiry,
      e_setupAcknowledge,
      e_notify
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_Setup_UUIE &() const;
#else
    operator H225_Setup_UUIE &();
    operator const H225_Setup_UUIE &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_CallProceeding_UUIE &() const;
#else
    operator H225_CallProceeding_UUIE &();
    operator const H225_CallProceeding_UUIE &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_Connect_UUIE &() const;
#else
    operator H225_Connect_UUIE &();
    operator const H225_Connect_UUIE &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_Alerting_UUIE &() const;
#else
    operator H225_Alerting_UUIE &();
    operator const H225_Alerting_UUIE &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_Information_UUIE &() const;
#else
    operator H225_Information_UUIE &();
    operator const H225_Information_UUIE &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_ReleaseComplete_UUIE &() const;
#else
    operator H225_ReleaseComplete_UUIE &();
    operator const H225_ReleaseComplete_UUIE &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_Facility_UUIE &() const;
#else
    operator H225_Facility_UUIE &();
    operator const H225_Facility_UUIE &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_Progress_UUIE &() const;
#else
    operator H225_Progress_UUIE &();
    operator const H225_Progress_UUIE &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_Status_UUIE &() const;
#else
    operator H225_Status_UUIE &();
    operator const H225_Status_UUIE &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_StatusInquiry_UUIE &() const;
#else
    operator H225_StatusInquiry_UUIE &();
    operator const H225_StatusInquiry_UUIE &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_SetupAcknowledge_UUIE &() const;
#else
    operator H225_SetupAcknowledge_UUIE &();
    operator const H225_SetupAcknowledge_UUIE &() const;
#endif
#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_Notify_UUIE &() const;
#else
    operator H225_Notify_UUIE &();
    operator const H225_Notify_UUIE &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// ArrayOf_SAsnOctetString
//

class H225_ArrayOf_SAsnOctetString : public SAsnArray
{
  public:
    H225_ArrayOf_SAsnOctetString(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    SAsnOctetString & H225_ArrayOf_SAsnOctetString::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_NonStandardParameter
//

class H225_NonStandardParameter;

class H225_ArrayOf_NonStandardParameter : public SAsnArray
{
  public:
    H225_ArrayOf_NonStandardParameter(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_NonStandardParameter & H225_ArrayOf_NonStandardParameter::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_GenericData
//

class H225_GenericData;

class H225_ArrayOf_GenericData : public SAsnArray
{
  public:
    H225_ArrayOf_GenericData(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_GenericData & H225_ArrayOf_GenericData::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_ClearToken
//

class H235_ClearToken;

class H225_ArrayOf_ClearToken : public SAsnArray
{
  public:
    H225_ArrayOf_ClearToken(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H235_ClearToken & H225_ArrayOf_ClearToken::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_CryptoH323Token
//

class H225_CryptoH323Token;

class H225_ArrayOf_CryptoH323Token : public SAsnArray
{
  public:
    H225_ArrayOf_CryptoH323Token(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_CryptoH323Token & H225_ArrayOf_CryptoH323Token::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_AliasAddress
//

class H225_AliasAddress;

class H225_ArrayOf_AliasAddress : public SAsnArray
{
  public:
    H225_ArrayOf_AliasAddress(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_AliasAddress & H225_ArrayOf_AliasAddress::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_ServiceControlSession
//

class H225_ServiceControlSession;

class H225_ArrayOf_ServiceControlSession : public SAsnArray
{
  public:
    H225_ArrayOf_ServiceControlSession(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_ServiceControlSession & H225_ArrayOf_ServiceControlSession::operator[](int i) const;
    SObject * Clone() const;
};


//
// Connect-UUIE_language
//

class H225_Connect_UUIE_language : public SAsnArray
{
  public:
    H225_Connect_UUIE_language(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    SAsnIA5String & H225_Connect_UUIE_language::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_CallReferenceValue
//

class H225_CallReferenceValue;

class H225_ArrayOf_CallReferenceValue : public SAsnArray
{
  public:
    H225_ArrayOf_CallReferenceValue(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_CallReferenceValue & H225_ArrayOf_CallReferenceValue::operator[](int i) const;
    SObject * Clone() const;
};


//
// Setup-UUIE_conferenceGoal
//

class H225_Setup_UUIE_conferenceGoal : public SAsnChoice
{
  public:
    H225_Setup_UUIE_conferenceGoal(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_create,
      e_join,
      e_invite,
      e_capability_negotiation,
      e_callIndependentSupplementaryService
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// ArrayOf_H245Security
//

class H225_H245Security;

class H225_ArrayOf_H245Security : public SAsnArray
{
  public:
    H225_ArrayOf_H245Security(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_H245Security & H225_ArrayOf_H245Security::operator[](int i) const;
    SObject * Clone() const;
};


//
// Setup-UUIE_connectionParameters
//

class H225_Setup_UUIE_connectionParameters : public SAsnSequence
{
  public:
    H225_Setup_UUIE_connectionParameters(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    H225_ScnConnectionType m_connectionType;
    SAsnInteger m_numberOfScnConnections;
    H225_ScnConnectionAggregation m_connectionAggregation;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// Setup-UUIE_language
//

class H225_Setup_UUIE_language : public SAsnArray
{
  public:
    H225_Setup_UUIE_language(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    SAsnIA5String & H225_Setup_UUIE_language::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_SupportedProtocols
//

class H225_SupportedProtocols;

class H225_ArrayOf_SupportedProtocols : public SAsnArray
{
  public:
    H225_ArrayOf_SupportedProtocols(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_SupportedProtocols & H225_ArrayOf_SupportedProtocols::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_FeatureDescriptor
//

class H225_FeatureDescriptor;

class H225_ArrayOf_FeatureDescriptor : public SAsnArray
{
  public:
    H225_ArrayOf_FeatureDescriptor(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_FeatureDescriptor & H225_ArrayOf_FeatureDescriptor::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_ExtendedAliasAddress
//

class H225_ExtendedAliasAddress;

class H225_ArrayOf_ExtendedAliasAddress : public SAsnArray
{
  public:
    H225_ArrayOf_ExtendedAliasAddress(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_ExtendedAliasAddress & H225_ArrayOf_ExtendedAliasAddress::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_ConferenceList
//

class H225_ConferenceList;

class H225_ArrayOf_ConferenceList : public SAsnArray
{
  public:
    H225_ArrayOf_ConferenceList(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_ConferenceList & H225_ArrayOf_ConferenceList::operator[](int i) const;
    SObject * Clone() const;
};


//
// TransportAddress_ipAddress
//

class H225_TransportAddress_ipAddress : public SAsnSequence
{
  public:
    H225_TransportAddress_ipAddress(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnOctetString m_ip;
    SAsnInteger m_port;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// TransportAddress_ipxAddress
//

class H225_TransportAddress_ipxAddress : public SAsnSequence
{
  public:
    H225_TransportAddress_ipxAddress(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnOctetString m_node;
    SAsnOctetString m_netnum;
    SAsnOctetString m_port;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// TransportAddress_ip6Address
//

class H225_TransportAddress_ip6Address : public SAsnSequence
{
  public:
    H225_TransportAddress_ip6Address(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnOctetString m_ip;
    SAsnInteger m_port;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// ArrayOf_TunnelledProtocol
//

class H225_TunnelledProtocol;

class H225_ArrayOf_TunnelledProtocol : public SAsnArray
{
  public:
    H225_ArrayOf_TunnelledProtocol(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_TunnelledProtocol & H225_ArrayOf_TunnelledProtocol::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_DataRate
//

class H225_DataRate;

class H225_ArrayOf_DataRate : public SAsnArray
{
  public:
    H225_ArrayOf_DataRate(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_DataRate & H225_ArrayOf_DataRate::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_SupportedPrefix
//

class H225_SupportedPrefix;

class H225_ArrayOf_SupportedPrefix : public SAsnArray
{
  public:
    H225_ArrayOf_SupportedPrefix(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_SupportedPrefix & H225_ArrayOf_SupportedPrefix::operator[](int i) const;
    SObject * Clone() const;
};


//
// TunnelledProtocol_id
//

class H225_TunnelledProtocolAlternateIdentifier;

class H225_TunnelledProtocol_id : public SAsnChoice
{
  public:
    H225_TunnelledProtocol_id(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_tunnelledProtocolObjectID,
      e_tunnelledProtocolAlternateID
    };

#if defined(__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 9
    operator H225_TunnelledProtocolAlternateIdentifier &() const;
#else
    operator H225_TunnelledProtocolAlternateIdentifier &();
    operator const H225_TunnelledProtocolAlternateIdentifier &() const;
#endif

    bool CreateObject();
    SObject * Clone() const;
};


//
// AddressPattern_range
//

class H225_AddressPattern_range : public SAsnSequence
{
  public:
    H225_AddressPattern_range(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    H225_PartyNumber m_startOfRange;
    H225_PartyNumber m_endOfRange;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// ANSI-41-UIM_system-id
//

class H225_ANSI_41_UIM_system_id : public SAsnChoice
{
  public:
    H225_ANSI_41_UIM_system_id(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_sid,
      e_mid
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// ArrayOf_TransportAddress
//

class H225_TransportAddress;

class H225_ArrayOf_TransportAddress : public SAsnArray
{
  public:
    H225_ArrayOf_TransportAddress(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_TransportAddress & H225_ArrayOf_TransportAddress::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_AlternateGK
//

class H225_AlternateGK;

class H225_ArrayOf_AlternateGK : public SAsnArray
{
  public:
    H225_ArrayOf_AlternateGK(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_AlternateGK & H225_ArrayOf_AlternateGK::operator[](int i) const;
    SObject * Clone() const;
};


//
// CryptoH323Token_cryptoEPPwdHash
//

class H225_CryptoH323Token_cryptoEPPwdHash : public SAsnSequence
{
  public:
    H225_CryptoH323Token_cryptoEPPwdHash(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    H225_AliasAddress m_alias;
    H235_TimeStamp m_timeStamp;
    H235_HASHED<H235_EncodedPwdCertToken> m_token;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// CryptoH323Token_cryptoGKPwdHash
//

class H225_CryptoH323Token_cryptoGKPwdHash : public SAsnSequence
{
  public:
    H225_CryptoH323Token_cryptoGKPwdHash(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    H225_GatekeeperIdentifier m_gatekeeperId;
    H235_TimeStamp m_timeStamp;
    H235_HASHED<H235_EncodedPwdCertToken> m_token;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// CapacityReportingSpecification_when
//

class H225_CapacityReportingSpecification_when : public SAsnSequence
{
  public:
    H225_CapacityReportingSpecification_when(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_callStart,
      e_callEnd
    };

    SAsnNull m_callStart;
    SAsnNull m_callEnd;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// ArrayOf_CallsAvailable
//

class H225_CallsAvailable;

class H225_ArrayOf_CallsAvailable : public SAsnArray
{
  public:
    H225_ArrayOf_CallsAvailable(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_CallsAvailable & H225_ArrayOf_CallsAvailable::operator[](int i) const;
    SObject * Clone() const;
};


//
// CicInfo_cic
//

class H225_CicInfo_cic : public SAsnArray
{
  public:
    H225_CicInfo_cic(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    SAsnOctetString & H225_CicInfo_cic::operator[](int i) const;
    SObject * Clone() const;
};


//
// GroupID_member
//

class H225_GroupID_member : public SAsnArray
{
  public:
    H225_GroupID_member(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    SAsnInteger & H225_GroupID_member::operator[](int i) const;
    SObject * Clone() const;
};


//
// ServiceControlSession_reason
//

class H225_ServiceControlSession_reason : public SAsnChoice
{
  public:
    H225_ServiceControlSession_reason(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_open,
      e_refresh,
      e_close
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// RasUsageSpecification_when
//

class H225_RasUsageSpecification_when : public SAsnSequence
{
  public:
    H225_RasUsageSpecification_when(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_start,
      e_end,
      e_inIrr
    };

    SAsnNull m_start;
    SAsnNull m_end;
    SAsnNull m_inIrr;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// RasUsageSpecification_callStartingPoint
//

class H225_RasUsageSpecification_callStartingPoint : public SAsnSequence
{
  public:
    H225_RasUsageSpecification_callStartingPoint(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_alerting,
      e_connect
    };

    SAsnNull m_alerting;
    SAsnNull m_connect;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// CallCreditServiceControl_billingMode
//

class H225_CallCreditServiceControl_billingMode : public SAsnChoice
{
  public:
    H225_CallCreditServiceControl_billingMode(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_credit,
      e_debit
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// CallCreditServiceControl_callStartingPoint
//

class H225_CallCreditServiceControl_callStartingPoint : public SAsnChoice
{
  public:
    H225_CallCreditServiceControl_callStartingPoint(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_alerting,
      e_connect
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// ArrayOf_EnumeratedParameter
//

class H225_EnumeratedParameter;

class H225_ArrayOf_EnumeratedParameter : public SAsnArray
{
  public:
    H225_ArrayOf_EnumeratedParameter(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_EnumeratedParameter & H225_ArrayOf_EnumeratedParameter::operator[](int i) const;
    SObject * Clone() const;
};


//
// RTPSession_associatedSessionIds
//

class H225_RTPSession_associatedSessionIds : public SAsnArray
{
  public:
    H225_RTPSession_associatedSessionIds(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    SAsnInteger & H225_RTPSession_associatedSessionIds::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_Endpoint
//

class H225_Endpoint;

class H225_ArrayOf_Endpoint : public SAsnArray
{
  public:
    H225_ArrayOf_Endpoint(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_Endpoint & H225_ArrayOf_Endpoint::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_AuthenticationMechanism
//

class H235_AuthenticationMechanism;

class H225_ArrayOf_AuthenticationMechanism : public SAsnArray
{
  public:
    H225_ArrayOf_AuthenticationMechanism(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H235_AuthenticationMechanism & H225_ArrayOf_AuthenticationMechanism::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_SAsnObjectId
//

class H225_ArrayOf_SAsnObjectId : public SAsnArray
{
  public:
    H225_ArrayOf_SAsnObjectId(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    SAsnObjectId & H225_ArrayOf_SAsnObjectId::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_IntegrityMechanism
//

class H225_IntegrityMechanism;

class H225_ArrayOf_IntegrityMechanism : public SAsnArray
{
  public:
    H225_ArrayOf_IntegrityMechanism(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_IntegrityMechanism & H225_ArrayOf_IntegrityMechanism::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_AddressPattern
//

class H225_AddressPattern;

class H225_ArrayOf_AddressPattern : public SAsnArray
{
  public:
    H225_ArrayOf_AddressPattern(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_AddressPattern & H225_ArrayOf_AddressPattern::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_H248PackagesDescriptor
//

class H225_H248PackagesDescriptor;

class H225_ArrayOf_H248PackagesDescriptor : public SAsnArray
{
  public:
    H225_ArrayOf_H248PackagesDescriptor(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_H248PackagesDescriptor & H225_ArrayOf_H248PackagesDescriptor::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_RasUsageSpecification
//

class H225_RasUsageSpecification;

class H225_ArrayOf_RasUsageSpecification : public SAsnArray
{
  public:
    H225_ArrayOf_RasUsageSpecification(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_RasUsageSpecification & H225_ArrayOf_RasUsageSpecification::operator[](int i) const;
    SObject * Clone() const;
};


//
// RegistrationRejectReason_invalidTerminalAliases
//

class H225_RegistrationRejectReason_invalidTerminalAliases : public SAsnSequence
{
  public:
    H225_RegistrationRejectReason_invalidTerminalAliases(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_terminalAlias,
      e_terminalAliasPattern,
      e_supportedPrefixes
    };

    H225_ArrayOf_AliasAddress m_terminalAlias;
    H225_ArrayOf_AddressPattern m_terminalAliasPattern;
    H225_ArrayOf_SupportedPrefix m_supportedPrefixes;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// AdmissionConfirm_language
//

class H225_AdmissionConfirm_language : public SAsnArray
{
  public:
    H225_AdmissionConfirm_language(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    SAsnIA5String & H225_AdmissionConfirm_language::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_PartyNumber
//

class H225_PartyNumber;

class H225_ArrayOf_PartyNumber : public SAsnArray
{
  public:
    H225_ArrayOf_PartyNumber(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_PartyNumber & H225_ArrayOf_PartyNumber::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_BandwidthDetails
//

class H225_BandwidthDetails;

class H225_ArrayOf_BandwidthDetails : public SAsnArray
{
  public:
    H225_ArrayOf_BandwidthDetails(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_BandwidthDetails & H225_ArrayOf_BandwidthDetails::operator[](int i) const;
    SObject * Clone() const;
};


//
// InfoRequestResponse_perCallInfo
//

class H225_InfoRequestResponse_perCallInfo_subtype;

class H225_InfoRequestResponse_perCallInfo : public SAsnArray
{
  public:
    H225_InfoRequestResponse_perCallInfo(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_InfoRequestResponse_perCallInfo_subtype & H225_InfoRequestResponse_perCallInfo::operator[](int i) const;
    SObject * Clone() const;
};


//
// ServiceControlIndication_callSpecific
//

class H225_ServiceControlIndication_callSpecific : public SAsnSequence
{
  public:
    H225_ServiceControlIndication_callSpecific(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    H225_CallIdentifier m_callIdentifier;
    H225_ConferenceIdentifier m_conferenceID;
    SAsnBoolean m_answeredCall;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// ServiceControlResponse_result
//

class H225_ServiceControlResponse_result : public SAsnChoice
{
  public:
    H225_ServiceControlResponse_result(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_started,
      e_failed,
      e_stopped,
      e_notAvailable,
      e_neededFeatureNotSupported
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// TransportAddress_ipSourceRoute_route
//

class H225_TransportAddress_ipSourceRoute_route : public SAsnArray
{
  public:
    H225_TransportAddress_ipSourceRoute_route(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    SAsnOctetString & H225_TransportAddress_ipSourceRoute_route::operator[](int i) const;
    SObject * Clone() const;
};


//
// TransportAddress_ipSourceRoute_routing
//

class H225_TransportAddress_ipSourceRoute_routing : public SAsnChoice
{
  public:
    H225_TransportAddress_ipSourceRoute_routing(unsigned tag = 0, TagClass tagClass = UniversalTagClass);

    enum Choices {
      e_strict,
      e_loose
    };

    bool CreateObject();
    SObject * Clone() const;
};


//
// ArrayOf_RTPSession
//

class H225_RTPSession;

class H225_ArrayOf_RTPSession : public SAsnArray
{
  public:
    H225_ArrayOf_RTPSession(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_RTPSession & H225_ArrayOf_RTPSession::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_TransportChannelInfo
//

class H225_TransportChannelInfo;

class H225_ArrayOf_TransportChannelInfo : public SAsnArray
{
  public:
    H225_ArrayOf_TransportChannelInfo(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_TransportChannelInfo & H225_ArrayOf_TransportChannelInfo::operator[](int i) const;
    SObject * Clone() const;
};


//
// ArrayOf_ConferenceIdentifier
//

class H225_ConferenceIdentifier;

class H225_ArrayOf_ConferenceIdentifier : public SAsnArray
{
  public:
    H225_ArrayOf_ConferenceIdentifier(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_ConferenceIdentifier & H225_ArrayOf_ConferenceIdentifier::operator[](int i) const;
    SObject * Clone() const;
};


//
// InfoRequestResponse_perCallInfo_subtype_pdu
//

class H225_InfoRequestResponse_perCallInfo_subtype_pdu_subtype;

class H225_InfoRequestResponse_perCallInfo_subtype_pdu : public SAsnArray
{
  public:
    H225_InfoRequestResponse_perCallInfo_subtype_pdu(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnObject * CreateObject() const;
    H225_InfoRequestResponse_perCallInfo_subtype_pdu_subtype & H225_InfoRequestResponse_perCallInfo_subtype_pdu::operator[](int i) const;
    SObject * Clone() const;
};


//
// Status-UUIE
//

class H225_Status_UUIE : public SAsnSequence
{
  public:
    H225_Status_UUIE(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_tokens,
      e_cryptoTokens
    };

    H225_ProtocolIdentifier m_protocolIdentifier;
    H225_CallIdentifier m_callIdentifier;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// StatusInquiry-UUIE
//

class H225_StatusInquiry_UUIE : public SAsnSequence
{
  public:
    H225_StatusInquiry_UUIE(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_tokens,
      e_cryptoTokens
    };

    H225_ProtocolIdentifier m_protocolIdentifier;
    H225_CallIdentifier m_callIdentifier;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// SetupAcknowledge-UUIE
//

class H225_SetupAcknowledge_UUIE : public SAsnSequence
{
  public:
    H225_SetupAcknowledge_UUIE(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_tokens,
      e_cryptoTokens
    };

    H225_ProtocolIdentifier m_protocolIdentifier;
    H225_CallIdentifier m_callIdentifier;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// Notify-UUIE
//

class H225_Notify_UUIE : public SAsnSequence
{
  public:
    H225_Notify_UUIE(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_tokens,
      e_cryptoTokens
    };

    H225_ProtocolIdentifier m_protocolIdentifier;
    H225_CallIdentifier m_callIdentifier;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// VendorIdentifier
//

class H225_VendorIdentifier : public SAsnSequence
{
  public:
    H225_VendorIdentifier(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_productId,
      e_versionId
    };

    H225_H221NonStandard m_vendor;
    SAsnOctetString m_productId;
    SAsnOctetString m_versionId;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// TunnelledProtocol
//

class H225_TunnelledProtocol : public SAsnSequence
{
  public:
    H225_TunnelledProtocol(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_subIdentifier
    };

    H225_TunnelledProtocol_id m_id;
    SAsnIA5String m_subIdentifier;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// NonStandardParameter
//

class H225_NonStandardParameter : public SAsnSequence
{
  public:
    H225_NonStandardParameter(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    H225_NonStandardIdentifier m_nonStandardIdentifier;
    SAsnOctetString m_data;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// PublicPartyNumber
//

class H225_PublicPartyNumber : public SAsnSequence
{
  public:
    H225_PublicPartyNumber(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    H225_PublicTypeOfNumber m_publicTypeOfNumber;
    H225_NumberDigits m_publicNumberDigits;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// PrivatePartyNumber
//

class H225_PrivatePartyNumber : public SAsnSequence
{
  public:
    H225_PrivatePartyNumber(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    H225_PrivateTypeOfNumber m_privateTypeOfNumber;
    H225_NumberDigits m_privateNumberDigits;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// ANSI-41-UIM
//

class H225_ANSI_41_UIM : public SAsnSequence
{
  public:
    H225_ANSI_41_UIM(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_imsi,
      e_min,
      e_mdn,
      e_msisdn,
      e_esn,
      e_mscid,
      e_systemMyTypeCode,
      e_systemAccessType,
      e_qualificationInformationCode,
      e_sesn,
      e_soc
    };

    SAsnIA5String m_imsi;
    SAsnIA5String m_min;
    SAsnIA5String m_mdn;
    SAsnIA5String m_msisdn;
    SAsnIA5String m_esn;
    SAsnIA5String m_mscid;
    H225_ANSI_41_UIM_system_id m_system_id;
    SAsnOctetString m_systemMyTypeCode;
    SAsnOctetString m_systemAccessType;
    SAsnOctetString m_qualificationInformationCode;
    SAsnIA5String m_sesn;
    SAsnIA5String m_soc;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// AlternateTransportAddresses
//

class H225_AlternateTransportAddresses : public SAsnSequence
{
  public:
    H225_AlternateTransportAddresses(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_annexE
    };

    H225_ArrayOf_TransportAddress m_annexE;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// AlternateGK
//

class H225_AlternateGK : public SAsnSequence
{
  public:
    H225_AlternateGK(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_gatekeeperIdentifier
    };

    H225_TransportAddress m_rasAddress;
    H225_GatekeeperIdentifier m_gatekeeperIdentifier;
    SAsnBoolean m_needToRegister;
    SAsnInteger m_priority;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// AltGKInfo
//

class H225_AltGKInfo : public SAsnSequence
{
  public:
    H225_AltGKInfo(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    H225_ArrayOf_AlternateGK m_alternateGatekeeper;
    SAsnBoolean m_altGKisPermanent;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// SecurityCapabilities
//

class H225_SecurityCapabilities : public SAsnSequence
{
  public:
    H225_SecurityCapabilities(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandard
    };

    H225_NonStandardParameter m_nonStandard;
    H225_SecurityServiceMode m_encryption;
    H225_SecurityServiceMode m_authenticaton;
    H225_SecurityServiceMode m_integrity;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// QseriesOptions
//

class H225_QseriesOptions : public SAsnSequence
{
  public:
    H225_QseriesOptions(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnBoolean m_q932Full;
    SAsnBoolean m_q951Full;
    SAsnBoolean m_q952Full;
    SAsnBoolean m_q953Full;
    SAsnBoolean m_q955Full;
    SAsnBoolean m_q956Full;
    SAsnBoolean m_q957Full;
    H225_Q954Details m_q954Info;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// DataRate
//

class H225_DataRate : public SAsnSequence
{
  public:
    H225_DataRate(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_channelMultiplier
    };

    H225_NonStandardParameter m_nonStandardData;
    H225_BandWidth m_channelRate;
    SAsnInteger m_channelMultiplier;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// SupportedPrefix
//

class H225_SupportedPrefix : public SAsnSequence
{
  public:
    H225_SupportedPrefix(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData
    };

    H225_NonStandardParameter m_nonStandardData;
    H225_AliasAddress m_prefix;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// CapacityReportingSpecification
//

class H225_CapacityReportingSpecification : public SAsnSequence
{
  public:
    H225_CapacityReportingSpecification(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    H225_CapacityReportingSpecification_when m_when;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// CallCapacityInfo
//

class H225_CallCapacityInfo : public SAsnSequence
{
  public:
    H225_CallCapacityInfo(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_voiceGwCallsAvailable,
      e_h310GwCallsAvailable,
      e_h320GwCallsAvailable,
      e_h321GwCallsAvailable,
      e_h322GwCallsAvailable,
      e_h323GwCallsAvailable,
      e_h324GwCallsAvailable,
      e_t120OnlyGwCallsAvailable,
      e_t38FaxAnnexbOnlyGwCallsAvailable,
      e_terminalCallsAvailable,
      e_mcuCallsAvailable
    };

    H225_ArrayOf_CallsAvailable m_voiceGwCallsAvailable;
    H225_ArrayOf_CallsAvailable m_h310GwCallsAvailable;
    H225_ArrayOf_CallsAvailable m_h320GwCallsAvailable;
    H225_ArrayOf_CallsAvailable m_h321GwCallsAvailable;
    H225_ArrayOf_CallsAvailable m_h322GwCallsAvailable;
    H225_ArrayOf_CallsAvailable m_h323GwCallsAvailable;
    H225_ArrayOf_CallsAvailable m_h324GwCallsAvailable;
    H225_ArrayOf_CallsAvailable m_t120OnlyGwCallsAvailable;
    H225_ArrayOf_CallsAvailable m_t38FaxAnnexbOnlyGwCallsAvailable;
    H225_ArrayOf_CallsAvailable m_terminalCallsAvailable;
    H225_ArrayOf_CallsAvailable m_mcuCallsAvailable;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// CicInfo
//

class H225_CicInfo : public SAsnSequence
{
  public:
    H225_CicInfo(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    H225_CicInfo_cic m_cic;
    SAsnOctetString m_pointCode;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// GroupID
//

class H225_GroupID : public SAsnSequence
{
  public:
    H225_GroupID(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_member
    };

    H225_GroupID_member m_member;
    SAsnIA5String m_group;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// ServiceControlSession
//

class H225_ServiceControlSession : public SAsnSequence
{
  public:
    H225_ServiceControlSession(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_contents
    };

    SAsnInteger m_sessionId;
    H225_ServiceControlDescriptor m_contents;
    H225_ServiceControlSession_reason m_reason;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// RasUsageInfoTypes
//

class H225_RasUsageInfoTypes : public SAsnSequence
{
  public:
    H225_RasUsageInfoTypes(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_startTime,
      e_endTime,
      e_terminationCause
    };

    H225_ArrayOf_NonStandardParameter m_nonStandardUsageTypes;
    SAsnNull m_startTime;
    SAsnNull m_endTime;
    SAsnNull m_terminationCause;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// RasUsageSpecification
//

class H225_RasUsageSpecification : public SAsnSequence
{
  public:
    H225_RasUsageSpecification(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_callStartingPoint
    };

    H225_RasUsageSpecification_when m_when;
    H225_RasUsageSpecification_callStartingPoint m_callStartingPoint;
    H225_RasUsageInfoTypes m_required;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// RasUsageInformation
//

class H225_RasUsageInformation : public SAsnSequence
{
  public:
    H225_RasUsageInformation(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_alertingTime,
      e_connectTime,
      e_endTime
    };

    H225_ArrayOf_NonStandardParameter m_nonStandardUsageFields;
    H235_TimeStamp m_alertingTime;
    H235_TimeStamp m_connectTime;
    H235_TimeStamp m_endTime;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// BandwidthDetails
//

class H225_BandwidthDetails : public SAsnSequence
{
  public:
    H225_BandwidthDetails(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnBoolean m_sender;
    SAsnBoolean m_multicast;
    H225_BandWidth m_bandwidth;
    H225_TransportChannelInfo m_rtcpAddresses;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// CallCreditServiceControl
//

class H225_CallCreditServiceControl : public SAsnSequence
{
  public:
    H225_CallCreditServiceControl(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_amountString,
      e_billingMode,
      e_callDurationLimit,
      e_enforceCallDurationLimit,
      e_callStartingPoint
    };

    SAsnBmpString m_amountString;
    H225_CallCreditServiceControl_billingMode m_billingMode;
    SAsnInteger m_callDurationLimit;
    SAsnBoolean m_enforceCallDurationLimit;
    H225_CallCreditServiceControl_callStartingPoint m_callStartingPoint;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// GenericData
//

class H225_GenericData : public SAsnSequence
{
  public:
    H225_GenericData(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_parameters
    };

    H225_GenericIdentifier m_id;
    H225_ArrayOf_EnumeratedParameter m_parameters;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// EnumeratedParameter
//

class H225_EnumeratedParameter : public SAsnSequence
{
  public:
    H225_EnumeratedParameter(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_content
    };

    H225_GenericIdentifier m_id;
    H225_Content m_content;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// FeatureSet
//

class H225_FeatureSet : public SAsnSequence
{
  public:
    H225_FeatureSet(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_neededFeatures,
      e_desiredFeatures,
      e_supportedFeatures
    };

    SAsnBoolean m_replacementFeatureSet;
    H225_ArrayOf_FeatureDescriptor m_neededFeatures;
    H225_ArrayOf_FeatureDescriptor m_desiredFeatures;
    H225_ArrayOf_FeatureDescriptor m_supportedFeatures;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// RTPSession
//

class H225_RTPSession : public SAsnSequence
{
  public:
    H225_RTPSession(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_multicast,
      e_bandwidth
    };

    H225_TransportChannelInfo m_rtpAddress;
    H225_TransportChannelInfo m_rtcpAddress;
    SAsnPrintableString m_cname;
    SAsnInteger m_ssrc;
    SAsnInteger m_sessionId;
    H225_RTPSession_associatedSessionIds m_associatedSessionIds;
    SAsnNull m_multicast;
    H225_BandWidth m_bandwidth;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// GatekeeperConfirm
//

class H225_GatekeeperConfirm : public SAsnSequence
{
  public:
    H225_GatekeeperConfirm(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_gatekeeperIdentifier,
      e_alternateGatekeeper,
      e_authenticationMode,
      e_tokens,
      e_cryptoTokens,
      e_algorithmOID,
      e_integrity,
      e_integrityCheckValue,
      e_featureSet,
      e_genericData
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_ProtocolIdentifier m_protocolIdentifier;
    H225_NonStandardParameter m_nonStandardData;
    H225_GatekeeperIdentifier m_gatekeeperIdentifier;
    H225_TransportAddress m_rasAddress;
    H225_ArrayOf_AlternateGK m_alternateGatekeeper;
    H235_AuthenticationMechanism m_authenticationMode;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    SAsnObjectId m_algorithmOID;
    H225_ArrayOf_IntegrityMechanism m_integrity;
    H225_ICV m_integrityCheckValue;
    H225_FeatureSet m_featureSet;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// GatekeeperReject
//

class H225_GatekeeperReject : public SAsnSequence
{
  public:
    H225_GatekeeperReject(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_gatekeeperIdentifier,
      e_altGKInfo,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_featureSet,
      e_genericData
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_ProtocolIdentifier m_protocolIdentifier;
    H225_NonStandardParameter m_nonStandardData;
    H225_GatekeeperIdentifier m_gatekeeperIdentifier;
    H225_GatekeeperRejectReason m_rejectReason;
    H225_AltGKInfo m_altGKInfo;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    H225_FeatureSet m_featureSet;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// RegistrationReject
//

class H225_RegistrationReject : public SAsnSequence
{
  public:
    H225_RegistrationReject(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_gatekeeperIdentifier,
      e_altGKInfo,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_featureSet,
      e_genericData
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_ProtocolIdentifier m_protocolIdentifier;
    H225_NonStandardParameter m_nonStandardData;
    H225_RegistrationRejectReason m_rejectReason;
    H225_GatekeeperIdentifier m_gatekeeperIdentifier;
    H225_AltGKInfo m_altGKInfo;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    H225_FeatureSet m_featureSet;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// UnregistrationRequest
//

class H225_UnregistrationRequest : public SAsnSequence
{
  public:
    H225_UnregistrationRequest(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_endpointAlias,
      e_nonStandardData,
      e_endpointIdentifier,
      e_alternateEndpoints,
      e_gatekeeperIdentifier,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_reason,
      e_endpointAliasPattern,
      e_supportedPrefixes,
      e_alternateGatekeeper,
      e_genericData
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_ArrayOf_TransportAddress m_callSignalAddress;
    H225_ArrayOf_AliasAddress m_endpointAlias;
    H225_NonStandardParameter m_nonStandardData;
    H225_EndpointIdentifier m_endpointIdentifier;
    H225_ArrayOf_Endpoint m_alternateEndpoints;
    H225_GatekeeperIdentifier m_gatekeeperIdentifier;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    H225_UnregRequestReason m_reason;
    H225_ArrayOf_AddressPattern m_endpointAliasPattern;
    H225_ArrayOf_SupportedPrefix m_supportedPrefixes;
    H225_ArrayOf_AlternateGK m_alternateGatekeeper;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// UnregistrationConfirm
//

class H225_UnregistrationConfirm : public SAsnSequence
{
  public:
    H225_UnregistrationConfirm(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_genericData
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// UnregistrationReject
//

class H225_UnregistrationReject : public SAsnSequence
{
  public:
    H225_UnregistrationReject(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_altGKInfo,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_genericData
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_UnregRejectReason m_rejectReason;
    H225_NonStandardParameter m_nonStandardData;
    H225_AltGKInfo m_altGKInfo;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// AdmissionReject
//

class H225_AdmissionReject : public SAsnSequence
{
  public:
    H225_AdmissionReject(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_altGKInfo,
      e_tokens,
      e_cryptoTokens,
      e_callSignalAddress,
      e_integrityCheckValue,
      e_serviceControl,
      e_featureSet,
      e_genericData
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_AdmissionRejectReason m_rejectReason;
    H225_NonStandardParameter m_nonStandardData;
    H225_AltGKInfo m_altGKInfo;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ArrayOf_TransportAddress m_callSignalAddress;
    H225_ICV m_integrityCheckValue;
    H225_ArrayOf_ServiceControlSession m_serviceControl;
    H225_FeatureSet m_featureSet;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// BandwidthReject
//

class H225_BandwidthReject : public SAsnSequence
{
  public:
    H225_BandwidthReject(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_altGKInfo,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_genericData
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_BandRejectReason m_rejectReason;
    H225_BandWidth m_allowedBandWidth;
    H225_NonStandardParameter m_nonStandardData;
    H225_AltGKInfo m_altGKInfo;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// LocationReject
//

class H225_LocationReject : public SAsnSequence
{
  public:
    H225_LocationReject(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_altGKInfo,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_featureSet,
      e_genericData,
      e_serviceControl
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_LocationRejectReason m_rejectReason;
    H225_NonStandardParameter m_nonStandardData;
    H225_AltGKInfo m_altGKInfo;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    H225_FeatureSet m_featureSet;
    H225_ArrayOf_GenericData m_genericData;
    H225_ArrayOf_ServiceControlSession m_serviceControl;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// DisengageReject
//

class H225_DisengageReject : public SAsnSequence
{
  public:
    H225_DisengageReject(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_altGKInfo,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_genericData
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_DisengageRejectReason m_rejectReason;
    H225_NonStandardParameter m_nonStandardData;
    H225_AltGKInfo m_altGKInfo;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// InfoRequest
//

class H225_InfoRequest : public SAsnSequence
{
  public:
    H225_InfoRequest(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_replyAddress,
      e_callIdentifier,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_uuiesRequested,
      e_callLinkage,
      e_usageInfoRequested,
      e_segmentedResponseSupported,
      e_nextSegmentRequested,
      e_capacityInfoRequested,
      e_genericData
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_CallReferenceValue m_callReferenceValue;
    H225_NonStandardParameter m_nonStandardData;
    H225_TransportAddress m_replyAddress;
    H225_CallIdentifier m_callIdentifier;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    H225_UUIEsRequested m_uuiesRequested;
    H225_CallLinkage m_callLinkage;
    H225_RasUsageInfoTypes m_usageInfoRequested;
    SAsnNull m_segmentedResponseSupported;
    SAsnInteger m_nextSegmentRequested;
    SAsnNull m_capacityInfoRequested;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// InfoRequestAck
//

class H225_InfoRequestAck : public SAsnSequence
{
  public:
    H225_InfoRequestAck(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// InfoRequestNak
//

class H225_InfoRequestNak : public SAsnSequence
{
  public:
    H225_InfoRequestNak(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_altGKInfo,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_NonStandardParameter m_nonStandardData;
    H225_InfoRequestNakReason m_nakReason;
    H225_AltGKInfo m_altGKInfo;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// NonStandardMessage
//

class H225_NonStandardMessage : public SAsnSequence
{
  public:
    H225_NonStandardMessage(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_featureSet,
      e_genericData
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    H225_FeatureSet m_featureSet;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// UnknownMessageResponse
//

class H225_UnknownMessageResponse : public SAsnSequence
{
  public:
    H225_UnknownMessageResponse(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_messageNotUnderstood
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    SAsnOctetString m_messageNotUnderstood;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// RequestInProgress
//

class H225_RequestInProgress : public SAsnSequence
{
  public:
    H225_RequestInProgress(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    SAsnInteger m_delay;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// ResourcesAvailableConfirm
//

class H225_ResourcesAvailableConfirm : public SAsnSequence
{
  public:
    H225_ResourcesAvailableConfirm(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_genericData
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_ProtocolIdentifier m_protocolIdentifier;
    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// ServiceControlIndication
//

class H225_ServiceControlIndication : public SAsnSequence
{
  public:
    H225_ServiceControlIndication(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_endpointIdentifier,
      e_callSpecific,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_featureSet,
      e_genericData
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_ServiceControlSession m_serviceControl;
    H225_EndpointIdentifier m_endpointIdentifier;
    H225_ServiceControlIndication_callSpecific m_callSpecific;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    H225_FeatureSet m_featureSet;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// ServiceControlResponse
//

class H225_ServiceControlResponse : public SAsnSequence
{
  public:
    H225_ServiceControlResponse(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_result,
      e_nonStandardData,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_featureSet,
      e_genericData
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_ServiceControlResponse_result m_result;
    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    H225_FeatureSet m_featureSet;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// H323-UU-PDU_tunnelledSignallingMessage
//

class H225_H323_UU_PDU_tunnelledSignallingMessage : public SAsnSequence
{
  public:
    H225_H323_UU_PDU_tunnelledSignallingMessage(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_tunnellingRequired,
      e_nonStandardData
    };

    H225_TunnelledProtocol m_tunnelledProtocolID;
    H225_ArrayOf_SAsnOctetString m_messageContent;
    SAsnNull m_tunnellingRequired;
    H225_NonStandardParameter m_nonStandardData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// TransportAddress_ipSourceRoute
//

class H225_TransportAddress_ipSourceRoute : public SAsnSequence
{
  public:
    H225_TransportAddress_ipSourceRoute(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SAsnOctetString m_ip;
    SAsnInteger m_port;
    H225_TransportAddress_ipSourceRoute_route m_route;
    H225_TransportAddress_ipSourceRoute_routing m_routing;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// RegistrationConfirm_preGrantedARQ
//

class H225_RegistrationConfirm_preGrantedARQ : public SAsnSequence
{
  public:
    H225_RegistrationConfirm_preGrantedARQ(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_irrFrequencyInCall,
      e_totalBandwidthRestriction,
      e_alternateTransportAddresses,
      e_useSpecifiedTransport
    };

    SAsnBoolean m_makeCall;
    SAsnBoolean m_useGKCallSignalAddressToMakeCall;
    SAsnBoolean m_answerCall;
    SAsnBoolean m_useGKCallSignalAddressToAnswer;
    SAsnInteger m_irrFrequencyInCall;
    H225_BandWidth m_totalBandwidthRestriction;
    H225_AlternateTransportAddresses m_alternateTransportAddresses;
    H225_UseSpecifiedTransport m_useSpecifiedTransport;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// StimulusControl
//

class H225_StimulusControl : public SAsnSequence
{
  public:
    H225_StimulusControl(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandard,
      e_isText,
      e_h248Message
    };

    H225_NonStandardParameter m_nonStandard;
    SAsnNull m_isText;
    SAsnOctetString m_h248Message;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// ConferenceList
//

class H225_ConferenceList : public SAsnSequence
{
  public:
    H225_ConferenceList(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_conferenceID,
      e_conferenceAlias,
      e_nonStandardData
    };

    H225_ConferenceIdentifier m_conferenceID;
    H225_AliasAddress m_conferenceAlias;
    H225_NonStandardParameter m_nonStandardData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// GatewayInfo
//

class H225_GatewayInfo : public SAsnSequence
{
  public:
    H225_GatewayInfo(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_protocol,
      e_nonStandardData
    };

    H225_ArrayOf_SupportedProtocols m_protocol;
    H225_NonStandardParameter m_nonStandardData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// H310Caps
//

class H225_H310Caps : public SAsnSequence
{
  public:
    H225_H310Caps(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_dataRatesSupported,
      e_supportedPrefixes
    };

    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_DataRate m_dataRatesSupported;
    H225_ArrayOf_SupportedPrefix m_supportedPrefixes;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// H320Caps
//

class H225_H320Caps : public SAsnSequence
{
  public:
    H225_H320Caps(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_dataRatesSupported,
      e_supportedPrefixes
    };

    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_DataRate m_dataRatesSupported;
    H225_ArrayOf_SupportedPrefix m_supportedPrefixes;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// H321Caps
//

class H225_H321Caps : public SAsnSequence
{
  public:
    H225_H321Caps(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_dataRatesSupported,
      e_supportedPrefixes
    };

    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_DataRate m_dataRatesSupported;
    H225_ArrayOf_SupportedPrefix m_supportedPrefixes;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// H322Caps
//

class H225_H322Caps : public SAsnSequence
{
  public:
    H225_H322Caps(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_dataRatesSupported,
      e_supportedPrefixes
    };

    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_DataRate m_dataRatesSupported;
    H225_ArrayOf_SupportedPrefix m_supportedPrefixes;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// H323Caps
//

class H225_H323Caps : public SAsnSequence
{
  public:
    H225_H323Caps(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_dataRatesSupported,
      e_supportedPrefixes
    };

    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_DataRate m_dataRatesSupported;
    H225_ArrayOf_SupportedPrefix m_supportedPrefixes;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// H324Caps
//

class H225_H324Caps : public SAsnSequence
{
  public:
    H225_H324Caps(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_dataRatesSupported,
      e_supportedPrefixes
    };

    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_DataRate m_dataRatesSupported;
    H225_ArrayOf_SupportedPrefix m_supportedPrefixes;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// VoiceCaps
//

class H225_VoiceCaps : public SAsnSequence
{
  public:
    H225_VoiceCaps(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_dataRatesSupported,
      e_supportedPrefixes
    };

    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_DataRate m_dataRatesSupported;
    H225_ArrayOf_SupportedPrefix m_supportedPrefixes;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// T120OnlyCaps
//

class H225_T120OnlyCaps : public SAsnSequence
{
  public:
    H225_T120OnlyCaps(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_dataRatesSupported,
      e_supportedPrefixes
    };

    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_DataRate m_dataRatesSupported;
    H225_ArrayOf_SupportedPrefix m_supportedPrefixes;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// NonStandardProtocol
//

class H225_NonStandardProtocol : public SAsnSequence
{
  public:
    H225_NonStandardProtocol(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_dataRatesSupported
    };

    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_DataRate m_dataRatesSupported;
    H225_ArrayOf_SupportedPrefix m_supportedPrefixes;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// T38FaxAnnexbOnlyCaps
//

class H225_T38FaxAnnexbOnlyCaps : public SAsnSequence
{
  public:
    H225_T38FaxAnnexbOnlyCaps(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_dataRatesSupported
    };

    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_DataRate m_dataRatesSupported;
    H225_ArrayOf_SupportedPrefix m_supportedPrefixes;
    H245_DataProtocolCapability m_t38FaxProtocol;
    H245_T38FaxProfile m_t38FaxProfile;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// McuInfo
//

class H225_McuInfo : public SAsnSequence
{
  public:
    H225_McuInfo(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_protocol
    };

    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_SupportedProtocols m_protocol;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// TerminalInfo
//

class H225_TerminalInfo : public SAsnSequence
{
  public:
    H225_TerminalInfo(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData
    };

    H225_NonStandardParameter m_nonStandardData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// GatekeeperInfo
//

class H225_GatekeeperInfo : public SAsnSequence
{
  public:
    H225_GatekeeperInfo(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData
    };

    H225_NonStandardParameter m_nonStandardData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// FeatureDescriptor
//

class H225_FeatureDescriptor : public H225_GenericData
{
  public:
    H225_FeatureDescriptor(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    SObject * Clone() const;
};


//
// CallCapacity
//

class H225_CallCapacity : public SAsnSequence
{
  public:
    H225_CallCapacity(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_maximumCallCapacity,
      e_currentCallCapacity
    };

    H225_CallCapacityInfo m_maximumCallCapacity;
    H225_CallCapacityInfo m_currentCallCapacity;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// CircuitIdentifier
//

class H225_CircuitIdentifier : public SAsnSequence
{
  public:
    H225_CircuitIdentifier(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_cic,
      e_group
    };

    H225_CicInfo m_cic;
    H225_GroupID m_group;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// RegistrationConfirm
//

class H225_RegistrationConfirm : public SAsnSequence
{
  public:
    H225_RegistrationConfirm(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_terminalAlias,
      e_gatekeeperIdentifier,
      e_alternateGatekeeper,
      e_timeToLive,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_willRespondToIRR,
      e_preGrantedARQ,
      e_maintainConnection,
      e_serviceControl,
      e_supportsAdditiveRegistration,
      e_terminalAliasPattern,
      e_supportedPrefixes,
      e_usageSpec,
      e_featureServerAlias,
      e_capacityReportingSpec,
      e_featureSet,
      e_genericData
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_ProtocolIdentifier m_protocolIdentifier;
    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_TransportAddress m_callSignalAddress;
    H225_ArrayOf_AliasAddress m_terminalAlias;
    H225_GatekeeperIdentifier m_gatekeeperIdentifier;
    H225_EndpointIdentifier m_endpointIdentifier;
    H225_ArrayOf_AlternateGK m_alternateGatekeeper;
    H225_TimeToLive m_timeToLive;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    SAsnBoolean m_willRespondToIRR;
    H225_RegistrationConfirm_preGrantedARQ m_preGrantedARQ;
    SAsnBoolean m_maintainConnection;
    H225_ArrayOf_ServiceControlSession m_serviceControl;
    SAsnNull m_supportsAdditiveRegistration;
    H225_ArrayOf_AddressPattern m_terminalAliasPattern;
    H225_ArrayOf_SupportedPrefix m_supportedPrefixes;
    H225_ArrayOf_RasUsageSpecification m_usageSpec;
    H225_AliasAddress m_featureServerAlias;
    H225_CapacityReportingSpecification m_capacityReportingSpec;
    H225_FeatureSet m_featureSet;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// BandwidthRequest
//

class H225_BandwidthRequest : public SAsnSequence
{
  public:
    H225_BandwidthRequest(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_callType,
      e_nonStandardData,
      e_callIdentifier,
      e_gatekeeperIdentifier,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_answeredCall,
      e_callLinkage,
      e_capacity,
      e_usageInformation,
      e_bandwidthDetails,
      e_genericData
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_EndpointIdentifier m_endpointIdentifier;
    H225_ConferenceIdentifier m_conferenceID;
    H225_CallReferenceValue m_callReferenceValue;
    H225_CallType m_callType;
    H225_BandWidth m_bandWidth;
    H225_NonStandardParameter m_nonStandardData;
    H225_CallIdentifier m_callIdentifier;
    H225_GatekeeperIdentifier m_gatekeeperIdentifier;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    SAsnBoolean m_answeredCall;
    H225_CallLinkage m_callLinkage;
    H225_CallCapacity m_capacity;
    H225_RasUsageInformation m_usageInformation;
    H225_ArrayOf_BandwidthDetails m_bandwidthDetails;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// BandwidthConfirm
//

class H225_BandwidthConfirm : public SAsnSequence
{
  public:
    H225_BandwidthConfirm(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_capacity,
      e_genericData
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_BandWidth m_bandWidth;
    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    H225_CallCapacity m_capacity;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// ResourcesAvailableIndicate
//

class H225_ResourcesAvailableIndicate : public SAsnSequence
{
  public:
    H225_ResourcesAvailableIndicate(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_capacity,
      e_genericData
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_ProtocolIdentifier m_protocolIdentifier;
    H225_NonStandardParameter m_nonStandardData;
    H225_EndpointIdentifier m_endpointIdentifier;
    H225_ArrayOf_SupportedProtocols m_protocols;
    SAsnBoolean m_almostOutOfResources;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    H225_CallCapacity m_capacity;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// H323-UU-PDU
//

class H225_H323_UU_PDU : public SAsnSequence
{
  public:
    H225_H323_UU_PDU(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_h4501SupplementaryService,
      e_h245Tunneling,
      e_h245Control,
      e_nonStandardControl,
      e_callLinkage,
      e_tunnelledSignallingMessage,
      e_provisionalRespToH245Tunneling,
      e_stimulusControl,
      e_genericData
    };

    H225_H323_UU_PDU_h323_message_body m_h323_message_body;
    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_SAsnOctetString m_h4501SupplementaryService;
    SAsnBoolean m_h245Tunneling;
    H225_ArrayOf_SAsnOctetString m_h245Control;
    H225_ArrayOf_NonStandardParameter m_nonStandardControl;
    H225_CallLinkage m_callLinkage;
    H225_H323_UU_PDU_tunnelledSignallingMessage m_tunnelledSignallingMessage;
    SAsnNull m_provisionalRespToH245Tunneling;
    H225_StimulusControl m_stimulusControl;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// ReleaseComplete-UUIE
//

class H225_ReleaseComplete_UUIE : public SAsnSequence
{
  public:
    H225_ReleaseComplete_UUIE(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_reason,
      e_callIdentifier,
      e_tokens,
      e_cryptoTokens,
      e_busyAddress,
      e_presentationIndicator,
      e_screeningIndicator,
      e_capacity,
      e_serviceControl,
      e_featureSet
    };

    H225_ProtocolIdentifier m_protocolIdentifier;
    H225_ReleaseCompleteReason m_reason;
    H225_CallIdentifier m_callIdentifier;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ArrayOf_AliasAddress m_busyAddress;
    H225_PresentationIndicator m_presentationIndicator;
    H225_ScreeningIndicator m_screeningIndicator;
    H225_CallCapacity m_capacity;
    H225_ArrayOf_ServiceControlSession m_serviceControl;
    H225_FeatureSet m_featureSet;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// EndpointType
//

class H225_EndpointType : public SAsnSequence
{
  public:
    H225_EndpointType(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_vendor,
      e_gatekeeper,
      e_gateway,
      e_mcu,
      e_terminal,
      e_set,
      e_supportedTunnelledProtocols
    };

    H225_NonStandardParameter m_nonStandardData;
    H225_VendorIdentifier m_vendor;
    H225_GatekeeperInfo m_gatekeeper;
    H225_GatewayInfo m_gateway;
    H225_McuInfo m_mcu;
    H225_TerminalInfo m_terminal;
    SAsnBoolean m_mc;
    SAsnBoolean m_undefinedNode;
    SAsnBitString m_set;
    H225_ArrayOf_TunnelledProtocol m_supportedTunnelledProtocols;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// Endpoint
//

class H225_Endpoint : public SAsnSequence
{
  public:
    H225_Endpoint(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_aliasAddress,
      e_callSignalAddress,
      e_rasAddress,
      e_endpointType,
      e_tokens,
      e_cryptoTokens,
      e_priority,
      e_remoteExtensionAddress,
      e_destExtraCallInfo,
      e_alternateTransportAddresses
    };

    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_AliasAddress m_aliasAddress;
    H225_ArrayOf_TransportAddress m_callSignalAddress;
    H225_ArrayOf_TransportAddress m_rasAddress;
    H225_EndpointType m_endpointType;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    SAsnInteger m_priority;
    H225_ArrayOf_AliasAddress m_remoteExtensionAddress;
    H225_ArrayOf_AliasAddress m_destExtraCallInfo;
    H225_AlternateTransportAddresses m_alternateTransportAddresses;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// CircuitInfo
//

class H225_CircuitInfo : public SAsnSequence
{
  public:
    H225_CircuitInfo(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_sourceCircuitID,
      e_destinationCircuitID,
      e_genericData
    };

    H225_CircuitIdentifier m_sourceCircuitID;
    H225_CircuitIdentifier m_destinationCircuitID;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// GatekeeperRequest
//

class H225_GatekeeperRequest : public SAsnSequence
{
  public:
    H225_GatekeeperRequest(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_gatekeeperIdentifier,
      e_callServices,
      e_endpointAlias,
      e_alternateEndpoints,
      e_tokens,
      e_cryptoTokens,
      e_authenticationCapability,
      e_algorithmOIDs,
      e_integrity,
      e_integrityCheckValue,
      e_supportsAltGK,
      e_featureSet,
      e_genericData
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_ProtocolIdentifier m_protocolIdentifier;
    H225_NonStandardParameter m_nonStandardData;
    H225_TransportAddress m_rasAddress;
    H225_EndpointType m_endpointType;
    H225_GatekeeperIdentifier m_gatekeeperIdentifier;
    H225_QseriesOptions m_callServices;
    H225_ArrayOf_AliasAddress m_endpointAlias;
    H225_ArrayOf_Endpoint m_alternateEndpoints;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ArrayOf_AuthenticationMechanism m_authenticationCapability;
    H225_ArrayOf_SAsnObjectId m_algorithmOIDs;
    H225_ArrayOf_IntegrityMechanism m_integrity;
    H225_ICV m_integrityCheckValue;
    SAsnNull m_supportsAltGK;
    H225_FeatureSet m_featureSet;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// RegistrationRequest
//

class H225_RegistrationRequest : public SAsnSequence
{
  public:
    H225_RegistrationRequest(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_terminalAlias,
      e_gatekeeperIdentifier,
      e_alternateEndpoints,
      e_timeToLive,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_keepAlive,
      e_endpointIdentifier,
      e_willSupplyUUIEs,
      e_maintainConnection,
      e_alternateTransportAddresses,
      e_additiveRegistration,
      e_terminalAliasPattern,
      e_supportsAltGK,
      e_usageReportingCapability,
      e_multipleCalls,
      e_supportedH248Packages,
      e_callCreditCapability,
      e_capacityReportingCapability,
      e_capacity,
      e_featureSet,
      e_genericData
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_ProtocolIdentifier m_protocolIdentifier;
    H225_NonStandardParameter m_nonStandardData;
    SAsnBoolean m_discoveryComplete;
    H225_ArrayOf_TransportAddress m_callSignalAddress;
    H225_ArrayOf_TransportAddress m_rasAddress;
    H225_EndpointType m_terminalType;
    H225_ArrayOf_AliasAddress m_terminalAlias;
    H225_GatekeeperIdentifier m_gatekeeperIdentifier;
    H225_VendorIdentifier m_endpointVendor;
    H225_ArrayOf_Endpoint m_alternateEndpoints;
    H225_TimeToLive m_timeToLive;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    SAsnBoolean m_keepAlive;
    H225_EndpointIdentifier m_endpointIdentifier;
    SAsnBoolean m_willSupplyUUIEs;
    SAsnBoolean m_maintainConnection;
    H225_AlternateTransportAddresses m_alternateTransportAddresses;
    SAsnNull m_additiveRegistration;
    H225_ArrayOf_AddressPattern m_terminalAliasPattern;
    SAsnNull m_supportsAltGK;
    H225_RasUsageInfoTypes m_usageReportingCapability;
    SAsnBoolean m_multipleCalls;
    H225_ArrayOf_H248PackagesDescriptor m_supportedH248Packages;
    H225_CallCreditCapability m_callCreditCapability;
    H225_CapacityReportingCapability m_capacityReportingCapability;
    H225_CallCapacity m_capacity;
    H225_FeatureSet m_featureSet;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// AdmissionRequest
//

class H225_AdmissionRequest : public SAsnSequence
{
  public:
    H225_AdmissionRequest(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_callModel,
      e_destinationInfo,
      e_destCallSignalAddress,
      e_destExtraCallInfo,
      e_srcCallSignalAddress,
      e_nonStandardData,
      e_callServices,
      e_canMapAlias,
      e_callIdentifier,
      e_srcAlternatives,
      e_destAlternatives,
      e_gatekeeperIdentifier,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_transportQOS,
      e_willSupplyUUIEs,
      e_callLinkage,
      e_gatewayDataRate,
      e_capacity,
      e_circuitInfo,
      e_desiredProtocols,
      e_desiredTunnelledProtocol,
      e_featureSet,
      e_genericData
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_CallType m_callType;
    H225_CallModel m_callModel;
    H225_EndpointIdentifier m_endpointIdentifier;
    H225_ArrayOf_AliasAddress m_destinationInfo;
    H225_TransportAddress m_destCallSignalAddress;
    H225_ArrayOf_AliasAddress m_destExtraCallInfo;
    H225_ArrayOf_AliasAddress m_srcInfo;
    H225_TransportAddress m_srcCallSignalAddress;
    H225_BandWidth m_bandWidth;
    H225_CallReferenceValue m_callReferenceValue;
    H225_NonStandardParameter m_nonStandardData;
    H225_QseriesOptions m_callServices;
    H225_ConferenceIdentifier m_conferenceID;
    SAsnBoolean m_activeMC;
    SAsnBoolean m_answerCall;
    SAsnBoolean m_canMapAlias;
    H225_CallIdentifier m_callIdentifier;
    H225_ArrayOf_Endpoint m_srcAlternatives;
    H225_ArrayOf_Endpoint m_destAlternatives;
    H225_GatekeeperIdentifier m_gatekeeperIdentifier;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    H225_TransportQOS m_transportQOS;
    SAsnBoolean m_willSupplyUUIEs;
    H225_CallLinkage m_callLinkage;
    H225_DataRate m_gatewayDataRate;
    H225_CallCapacity m_capacity;
    H225_CircuitInfo m_circuitInfo;
    H225_ArrayOf_SupportedProtocols m_desiredProtocols;
    H225_TunnelledProtocol m_desiredTunnelledProtocol;
    H225_FeatureSet m_featureSet;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// AdmissionConfirm
//

class H225_AdmissionConfirm : public SAsnSequence
{
  public:
    H225_AdmissionConfirm(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_irrFrequency,
      e_nonStandardData,
      e_destinationInfo,
      e_destExtraCallInfo,
      e_destinationType,
      e_remoteExtensionAddress,
      e_alternateEndpoints,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_transportQOS,
      e_willRespondToIRR,
      e_uuiesRequested,
      e_language,
      e_alternateTransportAddresses,
      e_useSpecifiedTransport,
      e_circuitInfo,
      e_usageSpec,
      e_supportedProtocols,
      e_serviceControl,
      e_multipleCalls,
      e_featureSet,
      e_genericData
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_BandWidth m_bandWidth;
    H225_CallModel m_callModel;
    H225_TransportAddress m_destCallSignalAddress;
    SAsnInteger m_irrFrequency;
    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_AliasAddress m_destinationInfo;
    H225_ArrayOf_AliasAddress m_destExtraCallInfo;
    H225_EndpointType m_destinationType;
    H225_ArrayOf_AliasAddress m_remoteExtensionAddress;
    H225_ArrayOf_Endpoint m_alternateEndpoints;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    H225_TransportQOS m_transportQOS;
    SAsnBoolean m_willRespondToIRR;
    H225_UUIEsRequested m_uuiesRequested;
    H225_AdmissionConfirm_language m_language;
    H225_AlternateTransportAddresses m_alternateTransportAddresses;
    H225_UseSpecifiedTransport m_useSpecifiedTransport;
    H225_CircuitInfo m_circuitInfo;
    H225_ArrayOf_RasUsageSpecification m_usageSpec;
    H225_ArrayOf_SupportedProtocols m_supportedProtocols;
    H225_ArrayOf_ServiceControlSession m_serviceControl;
    SAsnBoolean m_multipleCalls;
    H225_FeatureSet m_featureSet;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// LocationRequest
//

class H225_LocationRequest : public SAsnSequence
{
  public:
    H225_LocationRequest(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_endpointIdentifier,
      e_nonStandardData,
      e_sourceInfo,
      e_canMapAlias,
      e_gatekeeperIdentifier,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_desiredProtocols,
      e_desiredTunnelledProtocol,
      e_featureSet,
      e_genericData,
      e_hopCount,
      e_circuitInfo
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_EndpointIdentifier m_endpointIdentifier;
    H225_ArrayOf_AliasAddress m_destinationInfo;
    H225_NonStandardParameter m_nonStandardData;
    H225_TransportAddress m_replyAddress;
    H225_ArrayOf_AliasAddress m_sourceInfo;
    SAsnBoolean m_canMapAlias;
    H225_GatekeeperIdentifier m_gatekeeperIdentifier;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    H225_ArrayOf_SupportedProtocols m_desiredProtocols;
    H225_TunnelledProtocol m_desiredTunnelledProtocol;
    H225_FeatureSet m_featureSet;
    H225_ArrayOf_GenericData m_genericData;
    SAsnInteger m_hopCount;
    H225_CircuitInfo m_circuitInfo;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// LocationConfirm
//

class H225_LocationConfirm : public SAsnSequence
{
  public:
    H225_LocationConfirm(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_destinationInfo,
      e_destExtraCallInfo,
      e_destinationType,
      e_remoteExtensionAddress,
      e_alternateEndpoints,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_alternateTransportAddresses,
      e_supportedProtocols,
      e_multipleCalls,
      e_featureSet,
      e_genericData,
      e_circuitInfo,
      e_serviceControl
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_TransportAddress m_callSignalAddress;
    H225_TransportAddress m_rasAddress;
    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_AliasAddress m_destinationInfo;
    H225_ArrayOf_AliasAddress m_destExtraCallInfo;
    H225_EndpointType m_destinationType;
    H225_ArrayOf_AliasAddress m_remoteExtensionAddress;
    H225_ArrayOf_Endpoint m_alternateEndpoints;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    H225_AlternateTransportAddresses m_alternateTransportAddresses;
    H225_ArrayOf_SupportedProtocols m_supportedProtocols;
    SAsnBoolean m_multipleCalls;
    H225_FeatureSet m_featureSet;
    H225_ArrayOf_GenericData m_genericData;
    H225_CircuitInfo m_circuitInfo;
    H225_ArrayOf_ServiceControlSession m_serviceControl;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// DisengageRequest
//

class H225_DisengageRequest : public SAsnSequence
{
  public:
    H225_DisengageRequest(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_callIdentifier,
      e_gatekeeperIdentifier,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_answeredCall,
      e_callLinkage,
      e_capacity,
      e_circuitInfo,
      e_usageInformation,
      e_terminationCause,
      e_serviceControl,
      e_genericData
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_EndpointIdentifier m_endpointIdentifier;
    H225_ConferenceIdentifier m_conferenceID;
    H225_CallReferenceValue m_callReferenceValue;
    H225_DisengageReason m_disengageReason;
    H225_NonStandardParameter m_nonStandardData;
    H225_CallIdentifier m_callIdentifier;
    H225_GatekeeperIdentifier m_gatekeeperIdentifier;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    SAsnBoolean m_answeredCall;
    H225_CallLinkage m_callLinkage;
    H225_CallCapacity m_capacity;
    H225_CircuitInfo m_circuitInfo;
    H225_RasUsageInformation m_usageInformation;
    H225_CallTerminationCause m_terminationCause;
    H225_ArrayOf_ServiceControlSession m_serviceControl;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// DisengageConfirm
//

class H225_DisengageConfirm : public SAsnSequence
{
  public:
    H225_DisengageConfirm(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_capacity,
      e_circuitInfo,
      e_usageInformation,
      e_genericData
    };

    H225_RequestSeqNum m_requestSeqNum;
    H225_NonStandardParameter m_nonStandardData;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    H225_CallCapacity m_capacity;
    H225_CircuitInfo m_circuitInfo;
    H225_RasUsageInformation m_usageInformation;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// InfoRequestResponse
//

class H225_InfoRequestResponse : public SAsnSequence
{
  public:
    H225_InfoRequestResponse(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_endpointAlias,
      e_perCallInfo,
      e_tokens,
      e_cryptoTokens,
      e_integrityCheckValue,
      e_needResponse,
      e_capacity,
      e_irrStatus,
      e_unsolicited,
      e_genericData
    };

    H225_NonStandardParameter m_nonStandardData;
    H225_RequestSeqNum m_requestSeqNum;
    H225_EndpointType m_endpointType;
    H225_EndpointIdentifier m_endpointIdentifier;
    H225_TransportAddress m_rasAddress;
    H225_ArrayOf_TransportAddress m_callSignalAddress;
    H225_ArrayOf_AliasAddress m_endpointAlias;
    H225_InfoRequestResponse_perCallInfo m_perCallInfo;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ICV m_integrityCheckValue;
    SAsnBoolean m_needResponse;
    H225_CallCapacity m_capacity;
    H225_InfoRequestResponseStatus m_irrStatus;
    SAsnBoolean m_unsolicited;
    H225_ArrayOf_GenericData m_genericData;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// InfoRequestResponse_perCallInfo_subtype
//

class H225_InfoRequestResponse_perCallInfo_subtype : public SAsnSequence
{
  public:
    H225_InfoRequestResponse_perCallInfo_subtype(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_nonStandardData,
      e_originator,
      e_audio,
      e_video,
      e_data,
      e_callIdentifier,
      e_tokens,
      e_cryptoTokens,
      e_substituteConfIDs,
      e_pdu,
      e_callLinkage,
      e_usageInformation,
      e_circuitInfo
    };

    H225_NonStandardParameter m_nonStandardData;
    H225_CallReferenceValue m_callReferenceValue;
    H225_ConferenceIdentifier m_conferenceID;
    SAsnBoolean m_originator;
    H225_ArrayOf_RTPSession m_audio;
    H225_ArrayOf_RTPSession m_video;
    H225_ArrayOf_TransportChannelInfo m_data;
    H225_TransportChannelInfo m_h245;
    H225_TransportChannelInfo m_callSignaling;
    H225_CallType m_callType;
    H225_BandWidth m_bandWidth;
    H225_CallModel m_callModel;
    H225_CallIdentifier m_callIdentifier;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ArrayOf_ConferenceIdentifier m_substituteConfIDs;
    H225_InfoRequestResponse_perCallInfo_subtype_pdu m_pdu;
    H225_CallLinkage m_callLinkage;
    H225_RasUsageInformation m_usageInformation;
    H225_CircuitInfo m_circuitInfo;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// InfoRequestResponse_perCallInfo_subtype_pdu_subtype
//

class H225_InfoRequestResponse_perCallInfo_subtype_pdu_subtype : public SAsnSequence
{
  public:
    H225_InfoRequestResponse_perCallInfo_subtype_pdu_subtype(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    H225_H323_UU_PDU m_h323pdu;
    SAsnBoolean m_sent;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// H323-UserInformation
//

class H225_H323_UserInformation : public SAsnSequence
{
  public:
    H225_H323_UserInformation(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_user_data
    };

    H225_H323_UU_PDU m_h323_uu_pdu;
    H225_H323_UserInformation_user_data m_user_data;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// Alerting-UUIE
//

class H225_Alerting_UUIE : public SAsnSequence
{
  public:
    H225_Alerting_UUIE(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_h245Address,
      e_callIdentifier,
      e_h245SecurityMode,
      e_tokens,
      e_cryptoTokens,
      e_fastStart,
      e_multipleCalls,
      e_maintainConnection,
      e_alertingAddress,
      e_presentationIndicator,
      e_screeningIndicator,
      e_fastConnectRefused,
      e_serviceControl,
      e_capacity,
      e_featureSet
    };

    H225_ProtocolIdentifier m_protocolIdentifier;
    H225_EndpointType m_destinationInfo;
    H225_TransportAddress m_h245Address;
    H225_CallIdentifier m_callIdentifier;
    H225_H245Security m_h245SecurityMode;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ArrayOf_SAsnOctetString m_fastStart;
    SAsnBoolean m_multipleCalls;
    SAsnBoolean m_maintainConnection;
    H225_ArrayOf_AliasAddress m_alertingAddress;
    H225_PresentationIndicator m_presentationIndicator;
    H225_ScreeningIndicator m_screeningIndicator;
    SAsnNull m_fastConnectRefused;
    H225_ArrayOf_ServiceControlSession m_serviceControl;
    H225_CallCapacity m_capacity;
    H225_FeatureSet m_featureSet;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// CallProceeding-UUIE
//

class H225_CallProceeding_UUIE : public SAsnSequence
{
  public:
    H225_CallProceeding_UUIE(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_h245Address,
      e_callIdentifier,
      e_h245SecurityMode,
      e_tokens,
      e_cryptoTokens,
      e_fastStart,
      e_multipleCalls,
      e_maintainConnection,
      e_fastConnectRefused,
      e_featureSet
    };

    H225_ProtocolIdentifier m_protocolIdentifier;
    H225_EndpointType m_destinationInfo;
    H225_TransportAddress m_h245Address;
    H225_CallIdentifier m_callIdentifier;
    H225_H245Security m_h245SecurityMode;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ArrayOf_SAsnOctetString m_fastStart;
    SAsnBoolean m_multipleCalls;
    SAsnBoolean m_maintainConnection;
    SAsnNull m_fastConnectRefused;
    H225_FeatureSet m_featureSet;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// Connect-UUIE
//

class H225_Connect_UUIE : public SAsnSequence
{
  public:
    H225_Connect_UUIE(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_h245Address,
      e_callIdentifier,
      e_h245SecurityMode,
      e_tokens,
      e_cryptoTokens,
      e_fastStart,
      e_multipleCalls,
      e_maintainConnection,
      e_language,
      e_connectedAddress,
      e_presentationIndicator,
      e_screeningIndicator,
      e_fastConnectRefused,
      e_serviceControl,
      e_capacity,
      e_featureSet
    };

    H225_ProtocolIdentifier m_protocolIdentifier;
    H225_TransportAddress m_h245Address;
    H225_EndpointType m_destinationInfo;
    H225_ConferenceIdentifier m_conferenceID;
    H225_CallIdentifier m_callIdentifier;
    H225_H245Security m_h245SecurityMode;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ArrayOf_SAsnOctetString m_fastStart;
    SAsnBoolean m_multipleCalls;
    SAsnBoolean m_maintainConnection;
    H225_Connect_UUIE_language m_language;
    H225_ArrayOf_AliasAddress m_connectedAddress;
    H225_PresentationIndicator m_presentationIndicator;
    H225_ScreeningIndicator m_screeningIndicator;
    SAsnNull m_fastConnectRefused;
    H225_ArrayOf_ServiceControlSession m_serviceControl;
    H225_CallCapacity m_capacity;
    H225_FeatureSet m_featureSet;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// Information-UUIE
//

class H225_Information_UUIE : public SAsnSequence
{
  public:
    H225_Information_UUIE(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_callIdentifier,
      e_tokens,
      e_cryptoTokens,
      e_fastStart,
      e_fastConnectRefused,
      e_circuitInfo
    };

    H225_ProtocolIdentifier m_protocolIdentifier;
    H225_CallIdentifier m_callIdentifier;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ArrayOf_SAsnOctetString m_fastStart;
    SAsnNull m_fastConnectRefused;
    H225_CircuitInfo m_circuitInfo;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// Setup-UUIE
//

class H225_Setup_UUIE : public SAsnSequence
{
  public:
    H225_Setup_UUIE(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_h245Address,
      e_sourceAddress,
      e_destinationAddress,
      e_destCallSignalAddress,
      e_destExtraCallInfo,
      e_destExtraCRV,
      e_callServices,
      e_sourceCallSignalAddress,
      e_remoteExtensionAddress,
      e_callIdentifier,
      e_h245SecurityCapability,
      e_tokens,
      e_cryptoTokens,
      e_fastStart,
      e_mediaWaitForConnect,
      e_canOverlapSend,
      e_endpointIdentifier,
      e_multipleCalls,
      e_maintainConnection,
      e_connectionParameters,
      e_language,
      e_presentationIndicator,
      e_screeningIndicator,
      e_serviceControl,
      e_symmetricOperationRequired,
      e_capacity,
      e_circuitInfo,
      e_desiredProtocols,
      e_neededFeatures,
      e_desiredFeatures,
      e_supportedFeatures,
      e_parallelH245Control,
      e_additionalSourceAddresses
    };

    H225_ProtocolIdentifier m_protocolIdentifier;
    H225_TransportAddress m_h245Address;
    H225_ArrayOf_AliasAddress m_sourceAddress;
    H225_EndpointType m_sourceInfo;
    H225_ArrayOf_AliasAddress m_destinationAddress;
    H225_TransportAddress m_destCallSignalAddress;
    H225_ArrayOf_AliasAddress m_destExtraCallInfo;
    H225_ArrayOf_CallReferenceValue m_destExtraCRV;
    SAsnBoolean m_activeMC;
    H225_ConferenceIdentifier m_conferenceID;
    H225_Setup_UUIE_conferenceGoal m_conferenceGoal;
    H225_QseriesOptions m_callServices;
    H225_CallType m_callType;
    H225_TransportAddress m_sourceCallSignalAddress;
    H225_AliasAddress m_remoteExtensionAddress;
    H225_CallIdentifier m_callIdentifier;
    H225_ArrayOf_H245Security m_h245SecurityCapability;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ArrayOf_SAsnOctetString m_fastStart;
    SAsnBoolean m_mediaWaitForConnect;
    SAsnBoolean m_canOverlapSend;
    H225_EndpointIdentifier m_endpointIdentifier;
    SAsnBoolean m_multipleCalls;
    SAsnBoolean m_maintainConnection;
    H225_Setup_UUIE_connectionParameters m_connectionParameters;
    H225_Setup_UUIE_language m_language;
    H225_PresentationIndicator m_presentationIndicator;
    H225_ScreeningIndicator m_screeningIndicator;
    H225_ArrayOf_ServiceControlSession m_serviceControl;
    SAsnNull m_symmetricOperationRequired;
    H225_CallCapacity m_capacity;
    H225_CircuitInfo m_circuitInfo;
    H225_ArrayOf_SupportedProtocols m_desiredProtocols;
    H225_ArrayOf_FeatureDescriptor m_neededFeatures;
    H225_ArrayOf_FeatureDescriptor m_desiredFeatures;
    H225_ArrayOf_FeatureDescriptor m_supportedFeatures;
    H225_ArrayOf_SAsnOctetString m_parallelH245Control;
    H225_ArrayOf_ExtendedAliasAddress m_additionalSourceAddresses;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// Facility-UUIE
//

class H225_Facility_UUIE : public SAsnSequence
{
  public:
    H225_Facility_UUIE(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_alternativeAddress,
      e_alternativeAliasAddress,
      e_conferenceID,
      e_callIdentifier,
      e_destExtraCallInfo,
      e_remoteExtensionAddress,
      e_tokens,
      e_cryptoTokens,
      e_conferences,
      e_h245Address,
      e_fastStart,
      e_multipleCalls,
      e_maintainConnection,
      e_fastConnectRefused,
      e_serviceControl,
      e_circuitInfo,
      e_featureSet,
      e_destinationInfo,
      e_h245SecurityMode
    };

    H225_ProtocolIdentifier m_protocolIdentifier;
    H225_TransportAddress m_alternativeAddress;
    H225_ArrayOf_AliasAddress m_alternativeAliasAddress;
    H225_ConferenceIdentifier m_conferenceID;
    H225_FacilityReason m_reason;
    H225_CallIdentifier m_callIdentifier;
    H225_ArrayOf_AliasAddress m_destExtraCallInfo;
    H225_AliasAddress m_remoteExtensionAddress;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ArrayOf_ConferenceList m_conferences;
    H225_TransportAddress m_h245Address;
    H225_ArrayOf_SAsnOctetString m_fastStart;
    SAsnBoolean m_multipleCalls;
    SAsnBoolean m_maintainConnection;
    SAsnNull m_fastConnectRefused;
    H225_ArrayOf_ServiceControlSession m_serviceControl;
    H225_CircuitInfo m_circuitInfo;
    H225_FeatureSet m_featureSet;
    H225_EndpointType m_destinationInfo;
    H225_H245Security m_h245SecurityMode;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


//
// Progress-UUIE
//

class H225_Progress_UUIE : public SAsnSequence
{
  public:
    H225_Progress_UUIE(unsigned tag = UniversalSequence, TagClass tagClass = UniversalTagClass);

    enum OptionalFields {
      e_h245Address,
      e_h245SecurityMode,
      e_tokens,
      e_cryptoTokens,
      e_fastStart,
      e_multipleCalls,
      e_maintainConnection,
      e_fastConnectRefused
    };

    H225_ProtocolIdentifier m_protocolIdentifier;
    H225_EndpointType m_destinationInfo;
    H225_TransportAddress m_h245Address;
    H225_CallIdentifier m_callIdentifier;
    H225_H245Security m_h245SecurityMode;
    H225_ArrayOf_ClearToken m_tokens;
    H225_ArrayOf_CryptoH323Token m_cryptoTokens;
    H225_ArrayOf_SAsnOctetString m_fastStart;
    SAsnBoolean m_multipleCalls;
    SAsnBoolean m_maintainConnection;
    SAsnNull m_fastConnectRefused;

    int GetDataLength() const;
    bool Decode(SAsnStream & strm);
    void Encode(SAsnStream & strm) const;
#ifndef SASN_NOPRINTON
    void PrintOn(ostream & strm) const;
#endif
    Comparison Compare(const SObject & obj) const;
    SObject * Clone() const;
};


#endif // __H225_H


// End of h225.h
